#
# Config file to build on a mips processor (DECstation) running Ultrix 4.x
#
# @(#)config-mips.mk	1.26 3/7/96
# Copyright (c) 1991-1996 The Regents of the University of California.
#                       All Rights Reserved.
#		       
# Authors:  J. T. Buck, Kennard White
#

# --------------------------------------------------------------------
# |  Please see the file ``config-default.mk'' in this directory!    |
# --------------------------------------------------------------------
include $(ROOT)/mk/config-default.mk

# Get the g++ definitions; we override some below.
include $(ROOT)/mk/config-g++.mk

#
# Programs to use
#
RANLIB =	ranlib
CC =		gcc

# If we have g++, then compile Octtools with gcc.  ARCHs that are cfront
# based probably don't have gcc.
# OCT_CC is used in src/octtools/vem-{lib,bin}.mk
OCT_CC =	gcc -fwritable-strings

OPTIMIZER =	-O2
#-Wsynth is new in g++-2.6.x
WARNINGS =	-Wall -Wcast-qual -Wsynth
GPPFLAGS =	-G 0 -g $(MEMLOG) $(WARNINGS) $(OPTIMIZER)
# If you are not using gcc, then you might have problems with the WARNINGS flag
CFLAGS =	-G 0 -g $(MEMLOG) $(WARNINGS) $(OPTIMIZER)

#
# Variables for the linker
#
LINKFLAGS =	-L$(LIBDIR) -G 0 -N -Xlinker -x
LINKFLAGS_D =	-L$(LIBDIR) -G 0 -N

#
# Directories to use
#
X11_INCSPEC =	-I$(ROOT)/src/compat
X11_LIBSPEC =	-L/usr/X11/lib -lX11

# Variable for the Ariel DSP56000 board--- only used on sun4.
S56DIR =

# Variables for local Matlab installation
# -- If Matlab is installed, then MATLABDIR points to where MATLAB is installed 
#    and MATLABLIBDIR points to the directory containing the Matlab libraries
# -- If Matlab is not installed, then MATLABDIR equals $ROOT/src/compat/matlab
#    and MATLABLIBIDR is undefined
MATLABDIR =	/usr/sww/matlab
MATLABLIBDIR =	-L$(MATLABDIR)/extern/lib/dec_risc
