static const char file_id[] = "DEDomain.cc";
/**********************************************************************
Version identification:
@(#)DEDomain.cc	1.7	3/2/95

Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY

 Programmer:  J. T. Buck, Soonhoi Ha
 Date of creation: 8/18/92

 A device to produce the correct portholes, wormholes, event horizons,
 etc, for the DE domain so the interpreter can generate them dynamically.

***********************************************************************/

#include "Domain.h"
#include "DETarget.h"
#include "KnownTarget.h"
#include "DEScheduler.h"
#include "DEWormhole.h"
#include "DEPortHole.h"
#include "AutoForkNode.h"

extern const char DEdomainName[] = "DE";

class DEDomain : public Domain {
public:
	// new wormhole
	Star& newWorm(Galaxy& innerGal,Target* innerTarget)  {
		LOG_NEW; return *new DEWormhole(innerGal,innerTarget);
	}

	// new fromUniversal EventHorizon
	EventHorizon& newFrom() { LOG_NEW; return *new DEfromUniversal;}

	// new toUniversal EventHorizon
	EventHorizon& newTo() { LOG_NEW; return *new DEtoUniversal;}

	// constructor
	DEDomain() : Domain("DE") {
	  subDomains += "HOF";
	}
};

// declare a prototype
static DEDomain proto;

static DETarget defaultDEtarget;
static KnownTarget entry(defaultDEtarget,"default-DE");
