defstar {
	name { SrcGr }
	domain { HOF }
	derivedFrom { MapGr }
	desc {
Create one or more instances of the named block to produce the
required number of output stream(s).
This is implemented by replacing the SrcGr star with the named block
at setup time.
The replacement block(s) are connected as illustrated by the example
block that is connected.
Their parameters are determined by "parameter_map".
	}
	version { @(#)HOFSrcGr.pl	1.6 6/16/95 }
	author { Edward A. Lee }
	copyright {
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
	}
	location { HOF main library }
	explanation {
See the explanation for the
.c MapGr
star, from which this is derived.
The only difference is that this star forces the number of inputs to zero
and output datatype to float.
It also hides the input ports and the \fIinput_map\fR parameter.
.Sr "MapGr"
	}
	constructor {
	  output.setPort("output", this, FLOAT);
	  exin.setPort("exin", this, FLOAT);
	  input.setAttributes(P_HIDDEN);
	  exout.setAttributes(P_HIDDEN);
	}
}
