static const char file_id[] = "SDFFileSource.pl";
// .cc file generated from SDFFileSource.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liabi
lity, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFFileSource.h"
#include "FileMessage.h"
#include <iostream.h>

const char *star_nm_SDFFileSource = "SDFFileSource";

const char* SDFFileSource :: className() const {return star_nm_SDFFileSource;}

ISA_FUNC(SDFFileSource,SDFStar);

Block* SDFFileSource :: makeNew() const { LOG_NEW; return new SDFFileSource;}

SDFFileSource::SDFFileSource ()
{
	setDescriptor("Output the given file name on each firing.\nIf no name is given, then output a unique name of a temporary file\non each firing.");
	addPort(output.setPort("output",this,FILEMSG));
	addState(fileName.setState("fileName",this,"","File name to produce (use temporary file if empty)."));


}

void SDFFileSource::go() {
# line 34 "SDFFileSource.pl"
FileMessage* fm;
	const char* fn = (const char*) fileName;
	if (*fn == '\0') {
	    fm = new FileMessage();
	} else {
	    fm = new FileMessage(fn);
	}
	Envelope pkt(*fm);
	output%0 << pkt;
}

// prototype instance for known block list
static SDFFileSource proto;
static RegisterBlock registerBlock(proto,"FileSource");
