static const char file_id[] = "SDFMatlab.pl";
// .cc file generated from SDFMatlab.pl by ptlang
/*
Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.
See the file $PTOLEMY/copyright for copyright notice,
limitation of liability, and disclaimer of warranty provisions.
 */

#ifdef __GNUG__
#pragma implementation
#endif

#include "SDFMatlab.h"

const char *star_nm_SDFMatlab = "SDFMatlab";

const char* SDFMatlab :: className() const {return star_nm_SDFMatlab;}

ISA_FUNC(SDFMatlab,SDFStar);

Block* SDFMatlab :: makeNew() const { LOG_NEW; return new SDFMatlab;}

SDFMatlab::SDFMatlab ()
{
	setDescriptor("Base star for Matlab interface stars in the SDF domain.");
	addState(ScriptDirectory.setState("ScriptDirectory",this,"","An optional directory specifying where to find any custom Matlab files.\nYou may use tilde characters and environment variables in the directory name."));
	addState(DeleteOldFigures.setState("DeleteOldFigures",this,"YES","If this state is YES or TRUE, then old figures generated by Matlab\nwill be deleted whenever the destructor for this star is run, e.g.\nwhen the run panel in the graphical interface is closed."));

# line 78 "SDFMatlab.pl"
matlabInterface = 0;
}

void SDFMatlab::begin() {
# line 86 "SDFMatlab.pl"
if ( matlabInterface == 0 ) {
		    matlabInterface = new MatlabIfc;
		}
		if ( ! matlabInterface->MatlabIsRunning() ) {
		    if ( ! matlabInterface->StartMatlab() ) {
			Error::abortRun( *this,
					 matlabInterface->GetErrorString() );
			return;
		    }
		}

		const char* scriptDir = ScriptDirectory;
		matlabInterface->SetDeleteFigures( int(DeleteOldFigures) );
		matlabInterface->SetScriptDirectory( scriptDir );
		matlabInterface->SetFigureHandle( fullName() );
}

SDFMatlab::~SDFMatlab() {
# line 82 "SDFMatlab.pl"
delete matlabInterface;
}

// prototype instance for known block list
static SDFMatlab proto;
static RegisterBlock registerBlock(proto,"Matlab");
