
/*  A Bison parser, made from ptlang.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	DEFSTAR	258
#define	GALAXY	259
#define	NAME	260
#define	DESC	261
#define	DEFSTATE	262
#define	DOMAIN	263
#define	NUMPORTS	264
#define	NUM	265
#define	VIRTUAL	266
#define	DERIVED	267
#define	CONSTRUCTOR	268
#define	DESTRUCTOR	269
#define	STAR	270
#define	ALIAS	271
#define	INPUT	272
#define	OUTPUT	273
#define	INOUT	274
#define	ACCESS	275
#define	INMULTI	276
#define	OUTMULTI	277
#define	INOUTMULTI	278
#define	TYPE	279
#define	DEFAULT	280
#define	CLASS	281
#define	BEGIN	282
#define	SETUP	283
#define	GO	284
#define	WRAPUP	285
#define	CONNECT	286
#define	ID	287
#define	CCINCLUDE	288
#define	HINCLUDE	289
#define	PROTECTED	290
#define	PUBLIC	291
#define	PRIVATE	292
#define	METHOD	293
#define	ARGLIST	294
#define	CODE	295
#define	BODY	296
#define	IDENTIFIER	297
#define	STRING	298
#define	CONSCALLS	299
#define	ATTRIB	300
#define	LINE	301
#define	VERSION	302
#define	AUTHOR	303
#define	ACKNOWLEDGE	304
#define	COPYRIGHT	305
#define	EXPLANATION	306
#define	SEEALSO	307
#define	LOCATION	308
#define	CODEBLOCK	309
#define	EXECTIME	310
#define	PURE	311
#define	INLINE	312
#define	STATIC	313
#define	HEADER	314
#define	INITCODE	315
#define	START	316

#line 1 "ptlang.y"

/************************************************************************
 Version: @(#)ptlang.y	2.58 3/25/96

Copyright (c)1990-1996  The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the above
copyright notice and the following two paragraphs appear in all copies
of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY 
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES 
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF 
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF 
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

-----------------------------------------------------------------------

Ptolemy "star language" preprocessor.  This version does not support
compiled-in galaxies yet and the language may still change slightly.
Caveat hacker.

Programmer: J. T. Buck and E. A. Lee

6/9/95 tgl: handle default arguments in method arglists correctly.

************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <time.h>
#include <malloc.h>

/* Symbols for special characters*/
#define LPAR '('
#define RPAR ')'
#define QUOTE '"'
#define ESC '\\'
#define NEWLINE '\n'

/* buffer sizes */
#define BIGBUFSIZE 200000
#define MEDBUFSIZE 50000
#define SMALLBUFSIZE 512

/* number of code blocks allowed */
#define NUMCODEBLOCKS 100

#define FLEN 256
/* number of include files */
#define NINC 30
/* number of see alsos */
#define NSEE 30
#define NSTR 20

/* chars allowed in "identifier" */
#define IDENTCHAR(c) (isalnum(c) || c == '.' || c == '_')

char yytext[BIGBUFSIZE];	/* lexical analysis buffer */
int yyline = 1;			/* current input line */
int bodyMode = 0;		/* special lexan mode flag to read bodies  */
int docMode = 0;		/* flag document bodies  */
int descMode = 0;		/* flag descriptor bodies  */
int codeMode = 0;		/* flag code block bodies  */
FILE* yyin;			/* stream to read from */

char* progName = "ptlang";	/* program name */
int nerrs = 0;			/* # syntax errors detected */

char* blockID;			/* identifier for code blocks */
char* blockArg;
char* codeBlocks[NUMCODEBLOCKS];
char* codeBlockNames[NUMCODEBLOCKS];
char* codeBlockLines[NUMCODEBLOCKS];
char* codeBlockArgs[NUMCODEBLOCKS];
int numBlocks = 0;

/* scratch buffers */
char str1[SMALLBUFSIZE*2];
char str2[SMALLBUFSIZE*2];
char consStuff[BIGBUFSIZE];
char publicMembers[MEDBUFSIZE];
char protectedMembers[MEDBUFSIZE];
char privateMembers[MEDBUFSIZE];
char inputDescriptions[MEDBUFSIZE];
char outputDescriptions[MEDBUFSIZE];
char inoutDescriptions[MEDBUFSIZE];
char stateDescriptions[MEDBUFSIZE];
char ccCode[BIGBUFSIZE];
char hCode[BIGBUFSIZE];
char miscCode[BIGBUFSIZE];
char consCalls[BIGBUFSIZE];

/* state classes */
#define T_INT 0
#define T_FLOAT 1
#define T_COMPLEX 2
#define T_STRING 3
#define T_INTARRAY 4
#define T_FLOATARRAY 5
#define T_COMPLEXARRAY 6
#define T_FIX 7
#define T_FIXARRAY 8
#define T_STRINGARRAY 9
#define T_PRECISION 10
#define NSTATECLASSES 11

#define M_PURE 1
#define M_VIRTUAL 2
#define M_INLINE 4
#define M_STATIC 8

/* note: names must match order of symbols above */
char* stateClasses[] = {
"IntState", "FloatState", "ComplexState", "StringState",
"IntArrayState", "FloatArrayState", "ComplexArrayState",
"FixState", "FixArrayState", "StringArrayState", "PrecisionState"
};

/* bookkeeping for state include files */
int stateMarks[NSTATECLASSES];

/* external functions */
char* save();			/* duplicate a string */
char* savelineref();
char* ctime();
time_t time();
void exit();

/* forward declarations for functions */

char* whichMembers();
char* checkArgs();
char* stripQuotes();
char* portDataType();
int   stateTypeClass(), lookup(), yyparse(), yylex(), unescape();
void clearDefs(), clearStateDefs(), addMembers(), genState(), describeState(),
     initPort(), genPort(), describePort(), clearMethodDefs(), wrapMethod(),
     genInstance(), genStdProto(), yyerror(), yyerr2(), cvtCodeBlockExpr(),
     cvtCodeBlock(), genCodeBlock(), cvtMethod(), genMethod(), genDef(),
     yywarn(), mismatch(), genAlias(), stripDefaultArgs(),
     checkIncludes(), checkSeeAlsos();

char* inputFile;		/* input file name */
char* idBlock;			/* ID block */
char* objName;			/* name of star or galaxy class being decld  */
char* objVer;			/* sccs version number */
char* objDate;			/* date of last update */
char* objDesc;			/* descriptor of star or galaxy */
char* objAuthor;		/* author of star or galaxy */
char* objAcknowledge;		/* acknowledgements (previous authors) */
char* objCopyright;		/* copyright */
char* objExpl;			/* long explanation */
char* objLocation;		/* location string */
int   galDef;			/* true if obj is a galaxy */
char* domain;			/* domain of object (if star) */
char* derivedFrom;		/* class obj is derived from */
char* portName;			/* name of porthole */
char* portType;			/* dataType of porthole */
char* portInherit;		/* porthole for inheritTypeFrom */
char* portNum;			/* expr giving # of tokens */
char* portDesc;			/* port descriptor */
int   portDir;			/* 0=input, 1=output, 2=inout */
int   portMulti;		/* true if porthole is multiporthole */
char* portAttrib;		/* attributes for porthole */
char* stateName;		/* name of state */
char* stateClass;		/* class of state */
char* stateDef;			/* default value of state */
char* stateDesc;		/* descriptor for state */
char* stateAttrib;		/* attributes for state */
char* instName;			/* star instance within galaxy */
char* instClass;		/* class of star instance */
char* methodName;		/* name of user method */
char* methodArgs;		/* arglist of user method */
char* methodAccess;		/* protection of user method */
char* methodType;		/* return type of user method */
char* methodCode;		/* body of user method */
int   methodMode;		/* modifier flags for a method */
int   pureFlag;			/* if true, class is abstract */
char* galPortName;		/* name of galaxy port */

/* codes for "standard methods".  To add more, add them at the end,
 * modify N_FORMS, and put types in the codeType array and names in
 * the codeFuncName array.  The C_CONS is processed special.
 * C_SETUP and after are protected; rest are public.
 */
#define C_CONS 0
#define C_EXECTIME 1
#define C_WRAPUP 2
#define C_INITCODE 3
#define C_BEGIN 4
#define C_DEST 5
#define C_SETUP 6
#define C_GO 7


#define N_FORMS 8
char* codeBody[N_FORMS];		/* code bodies for each entity */
int inlineFlag[N_FORMS];		/* marks which are to be inline */
char destNameBuf[MEDBUFSIZE];		/* storage for destructor name */

/* types and names of standard member funcs */
char* codeType[] = {"","int ","void ","void ","void ","","void ","void "};
char* codeFuncName[] = {
"","myExecTime","wrapup","initCode","begin",destNameBuf,"setup","go"};

int methKey;			/* signals which of the standard funcs */

#define consCode codeBody[C_CONS]	/* extra constructor code */

char* hInclude[NINC];		/* include files in .h file */
int   nHInclude;		/* number of such files */
char* ccInclude[NINC];		/* include files in .cc file */
int   nCcInclude;		/* number of such files */
char* seeAlsoList[NSEE];	/* list of pointers to other manual sections */
int   nSeeAlso;			/* number of such pointers */

/* all tokens with values are type char *.  Keyword tokens
 * have their names as values.
 */
typedef char * STRINGVAL;
#define YYSTYPE STRINGVAL


#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		369
#define	YYFLAG		-32768
#define	YYNTBASE	74

#define YYTRANSLATE(x) ((unsigned)(x) <= 316 ? yytranslate[x] : 130)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,    69,    64,    71,     2,     2,    68,
    70,     2,     2,    72,     2,     2,    66,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    65,     2,     2,
    73,     2,     2,    67,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    63,     2,    62,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     8,     9,    12,    15,    18,    21,    22,
    28,    29,    35,    37,    40,    42,    45,    50,    55,    56,
    61,    62,    67,    68,    73,    74,    79,    80,    85,    86,
    91,    96,    97,   103,   107,   110,   113,   116,   121,   126,
   131,   136,   141,   144,   147,   149,   153,   156,   159,   163,
   167,   168,   170,   171,   173,   177,   179,   181,   183,   185,
   187,   189,   191,   193,   195,   215,   222,   234,   244,   251,
   258,   260,   262,   267,   272,   277,   278,   287,   288,   291,
   294,   296,   299,   300,   303,   308,   313,   318,   323,   326,
   329,   332,   335,   337,   339,   341,   343,   348,   353,   355,
   357,   359,   361,   363,   365,   367,   370,   375,   380,   386,
   391,   394,   395,   400,   402,   405,   410,   415,   420,   421,
   426,   429,   432,   434,   436,   438,   440,   443,   445,   447,
   449,   452,   457,   462,   464,   467,   472,   473,   477,   478,
   482,   483,   487,   488,   490,   492,   494,   496,   498,   500,
   502,   504,   506,   508,   510,   512,   514,   516,   518,   520,
   522,   524,   526,   528,   530,   532,   534,   536,   538,   540,
   542,   544,   546,   548,   550,   552,   554,   556,   558,   560,
   562,   564,   566,   568,   570,   572,   574,   576,   578,   580,
   582,   584,   586,   588,   590,   592
};

static const short yyrhs[] = {    75,
     0,    75,    62,     0,    75,   128,     0,     0,    75,    77,
     0,    75,    79,     0,    76,    41,     0,    32,    63,     0,
     0,     3,    78,    63,    81,    62,     0,     0,     4,    80,
    63,    82,    62,     0,    97,     0,    81,    97,     0,   108,
     0,    82,   108,     0,     5,    63,   128,    62,     0,    47,
    63,    96,    62,     0,     0,     6,    63,    84,    41,     0,
     0,    48,    63,    85,    41,     0,     0,    49,    63,    86,
    41,     0,     0,    50,    63,    87,    41,     0,     0,    53,
    63,    88,    41,     0,     0,    51,    63,    89,    41,     0,
    52,    63,   125,    62,     0,     0,     7,    90,    63,   113,
    62,     0,    92,    94,    41,     0,   106,    41,     0,   104,
    41,     0,   105,    41,     0,    91,    63,   101,    62,     0,
    33,    63,   124,    62,     0,    34,    63,   126,    62,     0,
    33,    63,     1,    62,     0,    34,    63,     1,    62,     0,
   100,    41,     0,     1,    62,     0,    38,     0,    56,    93,
    38,     0,    11,    38,     0,    58,    38,     0,    57,    58,
    38,     0,    57,    93,    38,     0,     0,    57,     0,     0,
    11,     0,    95,   102,    63,     0,    13,     0,    14,     0,
    27,     0,    28,     0,    29,     0,    30,     0,    60,     0,
    55,     0,    61,     0,    64,    42,    65,    42,    64,    64,
    42,    65,    42,    66,    42,    66,    42,    42,    65,    42,
    65,    42,    64,     0,    64,    42,    64,    64,    42,    64,
     0,    67,    68,    69,    70,    42,    42,    42,    66,    42,
    66,    42,     0,    67,    68,    69,    70,    42,    42,    42,
    42,    42,     0,    42,    42,    66,    42,    66,    42,     0,
    71,    42,    71,    71,    42,    71,     0,     1,     0,    83,
     0,     8,    63,   128,    62,     0,    12,    63,   128,    62,
     0,   109,    63,   110,    62,     0,     0,    54,    68,   128,
    99,    70,    63,    98,    41,     0,     0,    72,    43,     0,
    44,    63,     0,   103,     0,   101,   103,     0,     0,    68,
    70,     0,     5,    63,   128,    62,     0,    39,    63,   128,
    62,     0,    24,    63,   128,    62,     0,    20,    63,   107,
    62,     0,   104,    41,     0,    40,    63,     0,    59,    63,
     0,   107,    63,     0,    36,     0,    35,     0,    37,     0,
    83,     0,    15,    63,   120,    62,     0,    16,    63,   122,
    62,     0,    17,     0,    18,     0,    19,     0,    21,     0,
    22,     0,    23,     0,   111,     0,   110,   111,     0,     5,
    63,   128,    62,     0,    24,    63,   128,    62,     0,    24,
    63,    73,   128,    62,     0,    10,    63,   119,    62,     0,
   116,    41,     0,     0,     6,    63,   112,    41,     0,   114,
     0,   113,   114,     0,     5,    63,   128,    62,     0,    24,
    63,   128,    62,     0,    25,    63,   117,    62,     0,     0,
     6,    63,   115,    41,     0,   116,    41,     0,    45,    63,
     0,   118,     0,    42,     0,   129,     0,    43,     0,   118,
    43,     0,    42,     0,    43,     0,   121,     0,   120,   121,
     0,     5,    63,   128,    62,     0,    26,    63,   128,    62,
     0,   123,     0,   122,   123,     0,     5,    63,   128,    62,
     0,     0,   124,   127,    43,     0,     0,   125,   127,    42,
     0,     0,   126,   127,    43,     0,     0,    72,     0,   129,
     0,    42,     0,    43,     0,     3,     0,     4,     0,     5,
     0,     6,     0,     7,     0,     8,     0,     9,     0,    12,
     0,    13,     0,    14,     0,    15,     0,    16,     0,    17,
     0,    18,     0,    19,     0,    21,     0,    22,     0,    23,
     0,    24,     0,    25,     0,    27,     0,    28,     0,    29,
     0,    30,     0,    31,     0,    33,     0,    34,     0,    35,
     0,    36,     0,    37,     0,    38,     0,    39,     0,    40,
     0,    20,     0,    48,     0,    49,     0,    47,     0,    50,
     0,    51,     0,    61,     0,    52,     0,    53,     0,    54,
     0,    55,     0,    56,     0,    57,     0,    59,     0,    60,
     0,    58,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   248,   250,   253,   257,   259,   260,   261,   264,   267,   269,
   272,   273,   276,   277,   280,   281,   285,   287,   288,   289,
   292,   293,   296,   297,   300,   301,   304,   305,   308,   309,
   312,   313,   314,   317,   322,   323,   327,   331,   332,   333,
   334,   335,   336,   344,   349,   350,   351,   352,   353,   354,
   361,   362,   366,   367,   371,   375,   377,   378,   379,   380,
   381,   382,   383,   384,   391,   400,   412,   421,   431,   437,
   449,   454,   456,   457,   458,   460,   470,   475,   476,   479,
   482,   484,   488,   489,   493,   495,   496,   497,   498,   502,
   507,   512,   518,   519,   520,   524,   526,   527,   535,   537,
   538,   539,   540,   541,   544,   546,   549,   551,   552,   553,
   554,   555,   555,   560,   562,   565,   567,   571,   572,   573,
   576,   579,   582,   583,   587,   593,   594,   602,   603,   610,
   612,   615,   617,   620,   622,   625,   630,   631,   636,   637,
   641,   642,   646,   647,   652,   653,   655,   659,   659,   659,
   659,   659,   659,   659,   659,   660,   660,   660,   660,   661,
   661,   661,   661,   661,   661,   662,   663,   663,   663,   663,
   663,   663,   663,   663,   663,   663,   664,   664,   664,   664,
   664,   664,   664,   664,   664,   665,   665,   666,   666,   666,
   666,   666,   666,   666,   666,   666
};

static const char * const yytname[] = {   "$","error","$undefined.","DEFSTAR",
"GALAXY","NAME","DESC","DEFSTATE","DOMAIN","NUMPORTS","NUM","VIRTUAL","DERIVED",
"CONSTRUCTOR","DESTRUCTOR","STAR","ALIAS","INPUT","OUTPUT","INOUT","ACCESS",
"INMULTI","OUTMULTI","INOUTMULTI","TYPE","DEFAULT","CLASS","BEGIN","SETUP","GO",
"WRAPUP","CONNECT","ID","CCINCLUDE","HINCLUDE","PROTECTED","PUBLIC","PRIVATE",
"METHOD","ARGLIST","CODE","BODY","IDENTIFIER","STRING","CONSCALLS","ATTRIB",
"LINE","VERSION","AUTHOR","ACKNOWLEDGE","COPYRIGHT","EXPLANATION","SEEALSO",
"LOCATION","CODEBLOCK","EXECTIME","PURE","INLINE","STATIC","HEADER","INITCODE",
"START","'}'","'{'","'$'","':'","'/'","'@'","'('","'#'","')'","'%'","','","'='",
"full_file","file","id","stardef","@1","galdef","@2","starlist","gallist","sgitem",
"@3","@4","@5","@6","@7","@8","@9","method","inl","vopt","stdmethkey","stdkey2",
"version","staritem","@10","cbargs","conscalls","methlist","optp","methitem",
"code","header","members","protkey","galitem","portkey","portlist","portitem",
"@11","dstatelist","dstateitem","@12","attrib","defval","stringseq","expval",
"starinstlist","starinstitem","aliaslist","aliasitem","cclist","seealso","hlist",
"optcomma","ident","keyword",""
};
#endif

static const short yyr1[] = {     0,
    74,    74,    74,    75,    75,    75,    75,    76,    78,    77,
    80,    79,    81,    81,    82,    82,    83,    83,    84,    83,
    85,    83,    86,    83,    87,    83,    88,    83,    89,    83,
    83,    90,    83,    83,    83,    83,    83,    83,    83,    83,
    83,    83,    83,    83,    91,    91,    91,    91,    91,    91,
    92,    92,    93,    93,    94,    95,    95,    95,    95,    95,
    95,    95,    95,    95,    96,    96,    96,    96,    96,    96,
    96,    97,    97,    97,    97,    98,    97,    99,    99,   100,
   101,   101,   102,   102,   103,   103,   103,   103,   103,   104,
   105,   106,   107,   107,   107,   108,   108,   108,   109,   109,
   109,   109,   109,   109,   110,   110,   111,   111,   111,   111,
   111,   112,   111,   113,   113,   114,   114,   114,   115,   114,
   114,   116,   117,   117,   117,   118,   118,   119,   119,   120,
   120,   121,   121,   122,   122,   123,   124,   124,   125,   125,
   126,   126,   127,   127,   128,   128,   128,   129,   129,   129,
   129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
   129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
   129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
   129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
   129,   129,   129,   129,   129,   129
};

static const short yyr2[] = {     0,
     1,     2,     2,     0,     2,     2,     2,     2,     0,     5,
     0,     5,     1,     2,     1,     2,     4,     4,     0,     4,
     0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
     4,     0,     5,     3,     2,     2,     2,     4,     4,     4,
     4,     4,     2,     2,     1,     3,     2,     2,     3,     3,
     0,     1,     0,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,    19,     6,    11,     9,     6,     6,
     1,     1,     4,     4,     4,     0,     8,     0,     2,     2,
     1,     2,     0,     2,     4,     4,     4,     4,     2,     2,
     2,     2,     1,     1,     1,     1,     4,     4,     1,     1,
     1,     1,     1,     1,     1,     2,     4,     4,     5,     4,
     2,     0,     4,     1,     2,     4,     4,     4,     0,     4,
     2,     2,     1,     1,     1,     1,     2,     1,     1,     1,
     2,     4,     4,     1,     2,     4,     0,     3,     0,     3,
     0,     3,     0,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     4,
     0,     1,     0,     8,     9,    11,   150,   151,   152,   153,
   154,   155,   156,   157,   158,   159,   160,   161,   162,   181,
   163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
   173,   174,   175,   176,   177,   178,   179,   180,   146,   147,
   184,   182,   183,   185,   186,   188,   189,   190,   191,   192,
   193,   196,   194,   195,   187,     2,     5,     6,     3,   145,
     7,     0,     0,     0,     0,     0,     0,     0,    32,     0,
     0,     0,    99,   100,   101,   102,   103,   104,     0,     0,
    94,    93,    95,    45,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    53,    52,     0,     0,     0,    72,
     0,     0,    13,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    96,    15,    44,     0,    19,     0,     0,    47,
     0,     0,     0,    90,    80,     0,    21,    23,    25,    29,
   139,    27,     0,    54,     0,     0,     0,    48,    91,    10,
    14,     0,    56,    57,    58,    59,    60,    61,    63,    62,
    64,     0,    83,    43,    36,    37,    35,    92,     0,     0,
     0,    12,    16,   148,   149,     0,     0,     0,     0,     0,
     0,   143,     0,   143,    71,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   143,     0,    78,    46,    49,    50,
     0,     0,     0,     0,     0,    81,     0,    34,     0,     0,
     0,     0,     0,     0,     0,     0,   105,     0,     0,     0,
     0,   130,     0,     0,   134,    17,    20,     0,     0,     0,
     0,     0,   114,     0,    73,    74,    41,    39,   144,     0,
    42,    40,     0,     0,     0,     0,     0,    18,    22,    24,
    26,    30,    31,     0,    28,     0,     0,     0,     0,     0,
     0,    38,    82,    89,    84,    55,     0,   112,     0,     0,
   122,    75,   106,   111,     0,     0,    97,   131,     0,    98,
   135,     0,   119,     0,     0,    33,   115,   121,   138,   142,
     0,     0,     0,     0,     0,   140,    79,     0,     0,     0,
     0,     0,     0,     0,   128,   129,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   124,   126,     0,   123,   125,
     0,     0,     0,     0,     0,    76,    85,    88,    87,    86,
   107,   113,   110,     0,   108,   132,   133,   136,   116,   120,
   117,   118,   127,     0,     0,     0,     0,     0,     0,   109,
    69,    66,     0,     0,    70,    77,     0,     0,     0,     0,
     0,     0,    68,     0,     0,     0,     0,    67,     0,     0,
     0,     0,     0,     0,     0,    65,     0,     0,     0
};

static const short yydefgoto[] = {   367,
     2,     3,    57,    62,    58,    63,    99,   112,   100,   167,
   181,   182,   183,   186,   184,   118,   101,   102,   135,   152,
   153,   180,   103,   339,   247,   104,   195,   200,   196,   105,
   106,   107,   108,   114,   109,   206,   207,   294,   222,   223,
   304,   208,   308,   309,   297,   211,   212,   214,   215,   172,
   185,   174,   230,    59,    60
};

static const short yypact[] = {   -11,
   -38,   402,   -14,-32768,    33,    39,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    -7,    -5,    70,   343,     7,    22,    27,-32768,    46,
    58,    48,-32768,-32768,-32768,-32768,-32768,-32768,    49,    50,
-32768,-32768,-32768,-32768,    52,    53,    73,    74,    75,    76,
    77,    79,    80,    65,   134,    21,   108,    84,   219,-32768,
    85,   570,-32768,   110,   111,   113,   114,    94,   103,   104,
   125,   281,-32768,-32768,-32768,   462,-32768,   137,   462,-32768,
   462,     0,     1,-32768,-32768,     3,-32768,-32768,-32768,-32768,
-32768,-32768,   462,-32768,   159,   163,   164,-32768,-32768,-32768,
-32768,   581,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   177,   151,-32768,-32768,-32768,-32768,-32768,    10,    14,
   216,-32768,-32768,-32768,-32768,   160,   182,   259,   166,   172,
   173,   -26,   181,   -24,-32768,   197,   202,   183,   203,   188,
   217,   220,   221,   244,   -15,   248,   218,-32768,-32768,-32768,
   228,   230,   235,   236,     2,-32768,   260,-32768,   190,   237,
   239,   240,   242,   243,   249,     4,-32768,   266,   250,   257,
    24,-32768,   261,    18,-32768,-32768,-32768,   263,   264,   272,
   282,     6,-32768,   305,-32768,-32768,-32768,-32768,-32768,   279,
-32768,-32768,   280,   285,    30,   278,   284,-32768,-32768,-32768,
-32768,-32768,-32768,   310,-32768,   317,   283,   462,    17,   462,
   462,-32768,-32768,-32768,-32768,-32768,   462,-32768,    59,   156,
-32768,-32768,-32768,-32768,   462,   462,-32768,-32768,   462,-32768,
-32768,   462,-32768,   462,   521,-32768,-32768,-32768,-32768,-32768,
   319,   298,   321,   294,   295,-32768,-32768,   302,   306,   307,
   312,   313,   320,   326,-32768,-32768,   322,   462,   323,   324,
   327,   335,   350,   347,   351,-32768,-32768,   366,   391,-32768,
   377,   404,   383,   406,   430,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   411,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   446,   439,   442,   452,   436,   467,-32768,
-32768,-32768,   489,   490,-32768,-32768,   482,   -29,   511,   520,
   523,   500,-32768,   501,   543,   545,   522,-32768,   547,   548,
   526,   550,   528,   552,   531,-32768,   596,   602,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -47,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   507,-32768,
-32768,-32768,   505,-32768,-32768,-32768,-32768,-32768,   412,  -134,
-32768,-32768,   357,   496,-32768,-32768,   403,-32768,-32768,   388,
-32768,  -162,-32768,-32768,-32768,-32768,   400,-32768,   398,-32768,
-32768,-32768,  -150,  -116,   338
};


#define	YYLAST		631


static const short yytable[] = {   166,
   171,   173,   169,   175,   170,   224,   191,   197,   201,   202,
   218,   219,   350,   203,   201,   202,   187,   113,   209,   203,
     1,   192,   213,   233,     4,   193,    61,   204,   209,   220,
   221,   134,  -148,   204,   244,   228,   351,   232,  -149,   210,
   194,    85,  -137,  -141,   176,   229,   243,   229,   205,   210,
   205,    81,    82,    83,   205,    64,   229,    65,   -53,   224,
   197,  -137,  -141,   252,   113,   262,   177,   276,   115,   178,
    66,  -137,  -141,   179,    67,    68,    69,    70,   136,   270,
    71,    72,   -51,   -51,   116,   267,    73,    74,    75,   117,
    76,    77,    78,   282,   283,   120,   -51,   -51,   -51,   -51,
   295,   296,    79,    80,    81,    82,    83,    84,   119,    85,
   121,   122,   123,    86,   124,   125,    87,    88,    89,    90,
    91,    92,    93,    94,   -51,    95,    96,    97,    98,   -51,
   -51,   289,   133,   291,   292,   126,   127,   128,   129,   130,
   293,   131,   132,   299,   134,   138,   139,   142,   300,   301,
   154,   155,   302,   156,   157,   303,   158,   305,   164,   165,
     7,     8,     9,    10,    11,   159,   160,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,   324,    26,    27,    28,    29,    30,   161,    31,    32,
    33,    34,    35,    36,    37,    38,   188,    39,    40,   168,
   189,   190,    41,    42,    43,    44,    45,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,   198,   199,    66,
   213,   216,   217,    67,    68,    69,    70,   225,   298,    71,
    72,   -51,   -51,   226,   227,    73,    74,    75,   234,    76,
    77,    78,   231,   235,   237,   -51,   -51,   -51,   -51,   238,
   236,    79,    80,    81,    82,    83,    84,   239,    85,   255,
   240,   241,    86,   218,   219,    87,    88,    89,    90,    91,
    92,    93,    94,   -51,    95,    96,    97,    98,   -51,   -51,
   140,    66,   220,   221,   242,    67,    68,    69,   245,   246,
   248,    71,   249,   -51,   -51,   110,   111,   250,   251,   256,
   254,   257,   258,   205,   259,   260,   264,   -51,   -51,   -51,
   -51,   261,   265,    79,    80,    81,    82,    83,    84,   266,
    85,   279,   280,   269,    86,   272,   273,    87,    88,    89,
    90,    91,    92,    93,   274,   -51,    95,    96,    97,    98,
   -51,   -51,   162,    66,   275,   278,   284,    67,    68,    69,
   281,   286,   288,    71,   285,   -51,   -51,   110,   111,   287,
   311,   312,   313,   314,   316,   315,   322,   317,   318,   -51,
   -51,   -51,   -51,   319,   320,    79,    80,    81,    82,    83,
    84,   321,    85,   323,   325,   326,    86,   330,   327,    87,
    88,    89,    90,    91,    92,    93,   328,   -51,    95,    96,
    97,    98,   -51,   -51,     5,     6,     7,     8,     9,    10,
    11,   329,   331,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,   332,    26,    27,
    28,    29,    30,   333,    31,    32,    33,    34,    35,    36,
    37,    38,   334,    39,    40,   335,   336,   337,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    54,    55,    56,   164,   165,     7,     8,     9,    10,
    11,   338,   340,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,   341,    26,    27,
    28,    29,    30,   344,    31,    32,    33,    34,    35,    36,
    37,    38,   342,    39,    40,   343,   345,   346,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    54,    55,   164,   165,     7,     8,     9,    10,    11,
   347,   348,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,   349,    26,    27,    28,
    29,    30,   352,    31,    32,    33,    34,    35,    36,    37,
    38,   353,   306,   307,   354,   355,   356,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
    54,    55,   143,   144,   357,   191,   358,   359,   360,   361,
   362,   363,   364,   365,   366,   368,   145,   146,   147,   148,
   192,   369,   137,   141,   193,   290,   253,   163,   263,   277,
   268,   271,   310,     0,     0,     0,     0,     0,     0,   194,
    85,     0,     0,     0,   149,     0,     0,     0,     0,   150,
   151
};

static const short yycheck[] = {   116,
     1,     1,   119,     1,   121,   168,     5,   142,     5,     6,
     5,     6,    42,    10,     5,     6,   133,    65,     5,    10,
    32,    20,     5,   174,    63,    24,    41,    24,     5,    24,
    25,    11,     0,    24,   185,    62,    66,    62,     0,    26,
    39,    40,    43,    43,    42,    72,    62,    72,    45,    26,
    45,    35,    36,    37,    45,    63,    72,    63,    38,   222,
   195,    62,    62,    62,   112,    62,    64,    62,    62,    67,
     1,    72,    72,    71,     5,     6,     7,     8,    58,    62,
    11,    12,    13,    14,    63,    62,    17,    18,    19,    63,
    21,    22,    23,    64,    65,    38,    27,    28,    29,    30,
    42,    43,    33,    34,    35,    36,    37,    38,    63,    40,
    63,    63,    63,    44,    63,    63,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,   248,    68,   250,   251,    63,    63,    63,    63,    63,
   257,    63,    63,   260,    11,    38,    63,    63,   265,   266,
    41,    41,   269,    41,    41,   272,    63,   274,     3,     4,
     5,     6,     7,     8,     9,    63,    63,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
    25,   298,    27,    28,    29,    30,    31,    63,    33,    34,
    35,    36,    37,    38,    39,    40,    38,    42,    43,    63,
    38,    38,    47,    48,    49,    50,    51,    52,    53,    54,
    55,    56,    57,    58,    59,    60,    61,    41,    68,     1,
     5,    62,    41,     5,     6,     7,     8,    62,    73,    11,
    12,    13,    14,    62,    62,    17,    18,    19,    42,    21,
    22,    23,    62,    42,    42,    27,    28,    29,    30,    62,
    68,    33,    34,    35,    36,    37,    38,    41,    40,    70,
    41,    41,    44,     5,     6,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,     1,    24,    25,    41,     5,     6,     7,    41,    72,
    63,    11,    63,    13,    14,    15,    16,    63,    63,    63,
    41,    63,    63,    45,    63,    63,    41,    27,    28,    29,
    30,    63,    63,    33,    34,    35,    36,    37,    38,    63,
    40,    43,    43,    63,    44,    63,    63,    47,    48,    49,
    50,    51,    52,    53,    63,    55,    56,    57,    58,    59,
    60,    61,    62,     1,    63,    41,    69,     5,     6,     7,
    66,    42,    70,    11,    71,    13,    14,    15,    16,    43,
    42,    64,    42,    70,    63,    71,    41,    62,    62,    27,
    28,    29,    30,    62,    62,    33,    34,    35,    36,    37,
    38,    62,    40,    62,    62,    62,    44,    41,    62,    47,
    48,    49,    50,    51,    52,    53,    62,    55,    56,    57,
    58,    59,    60,    61,     3,     4,     5,     6,     7,     8,
     9,    62,    62,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    62,    27,    28,
    29,    30,    31,    43,    33,    34,    35,    36,    37,    38,
    39,    40,    66,    42,    43,    42,    64,    42,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,    62,     3,     4,     5,     6,     7,     8,
     9,    42,    62,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    24,    25,    42,    27,    28,
    29,    30,    31,    42,    33,    34,    35,    36,    37,    38,
    39,    40,    64,    42,    43,    64,    71,    41,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
    59,    60,    61,     3,     4,     5,     6,     7,     8,     9,
    42,    42,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    65,    27,    28,    29,
    30,    31,    42,    33,    34,    35,    36,    37,    38,    39,
    40,    42,    42,    43,    42,    66,    66,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    13,    14,    42,     5,    42,    66,    42,    42,
    65,    42,    65,    42,    64,     0,    27,    28,    29,    30,
    20,     0,    96,    99,    24,   249,   195,   112,   206,   222,
   211,   214,   275,    -1,    -1,    -1,    -1,    -1,    -1,    39,
    40,    -1,    -1,    -1,    55,    -1,    -1,    -1,    -1,    60,
    61
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/users/ptolemy/gnu/common/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/users/ptolemy/gnu/common/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 250 "ptlang.y"
{ yyerror("Too many closing curly braces");
			  exit(1);
			;
    break;}
case 3:
#line 253 "ptlang.y"
{ mismatch(yyvsp[0]);;
    break;}
case 7:
#line 261 "ptlang.y"
{ idBlock = yyvsp[0]; bodyMode = 0;;
    break;}
case 8:
#line 264 "ptlang.y"
{ bodyMode = 1;;
    break;}
case 9:
#line 268 "ptlang.y"
{ clearDefs(0);;
    break;}
case 10:
#line 269 "ptlang.y"
{ genDef();;
    break;}
case 11:
#line 272 "ptlang.y"
{ clearDefs(1);;
    break;}
case 12:
#line 273 "ptlang.y"
{ genDef();;
    break;}
case 17:
#line 286 "ptlang.y"
{ objName = yyvsp[-1];;
    break;}
case 18:
#line 287 "ptlang.y"
{ ;
    break;}
case 19:
#line 288 "ptlang.y"
{ descMode = 1; docMode = 1;;
    break;}
case 20:
#line 289 "ptlang.y"
{ objDesc = yyvsp[0];
					  docMode = 0;
					  descMode = 0;;
    break;}
case 21:
#line 292 "ptlang.y"
{ bodyMode = 1; docMode = 1;;
    break;}
case 22:
#line 293 "ptlang.y"
{ objAuthor = yyvsp[0];
					  docMode = 0;
					  bodyMode = 0;;
    break;}
case 23:
#line 296 "ptlang.y"
{ bodyMode = 1; docMode = 1;;
    break;}
case 24:
#line 297 "ptlang.y"
{ objAcknowledge = yyvsp[0];
					  docMode = 0;
					  bodyMode = 0;;
    break;}
case 25:
#line 300 "ptlang.y"
{ bodyMode = 1; docMode = 1;;
    break;}
case 26:
#line 301 "ptlang.y"
{ objCopyright = yyvsp[0];
					  docMode = 0;
					  bodyMode = 0;;
    break;}
case 27:
#line 304 "ptlang.y"
{ bodyMode = 1; docMode = 1;;
    break;}
case 28:
#line 305 "ptlang.y"
{ objLocation = yyvsp[0];
					  docMode = 0;
					  bodyMode = 0;;
    break;}
case 29:
#line 308 "ptlang.y"
{ bodyMode = 1; docMode = 1;;
    break;}
case 30:
#line 309 "ptlang.y"
{ objExpl = yyvsp[0];
					  bodyMode = 0;
					  docMode = 0;;
    break;}
case 31:
#line 312 "ptlang.y"
{ ;
    break;}
case 32:
#line 313 "ptlang.y"
{ clearStateDefs();;
    break;}
case 33:
#line 314 "ptlang.y"
{ genState(); describeState();;
    break;}
case 34:
#line 317 "ptlang.y"
{ inlineFlag[methKey] = yyvsp[-2] ? 1 : 0;
					  codeBody[methKey] = yyvsp[0];
					  bodyMode = 0;
					;
    break;}
case 35:
#line 322 "ptlang.y"
{ addMembers (yyvsp[-1], yyvsp[0]); bodyMode = 0;;
    break;}
case 36:
#line 323 "ptlang.y"
{ strcat (ccCode, yyvsp[0]); 
					  strcat (ccCode, "\n\n");
					  bodyMode = 0;
					;
    break;}
case 37:
#line 327 "ptlang.y"
{ strcat (hCode, yyvsp[0]);
					  strcat (hCode, "\n");
					  bodyMode = 0;
					;
    break;}
case 38:
#line 331 "ptlang.y"
{ wrapMethod();;
    break;}
case 39:
#line 332 "ptlang.y"
{ ;
    break;}
case 41:
#line 334 "ptlang.y"
{ yyerror("Error in ccinclude list");;
    break;}
case 42:
#line 335 "ptlang.y"
{ yyerror("Error in hinclude list");;
    break;}
case 43:
#line 336 "ptlang.y"
{ if(consCalls[0]) {
					     strcat(consCalls,", ");
					     strcat(consCalls,yyvsp[0]);
					  } else {
					     strcpy(consCalls,yyvsp[0]);
					  }
					  bodyMode = 0; 
					;
    break;}
case 44:
#line 344 "ptlang.y"
{ yyerror ("Illegal item");;
    break;}
case 45:
#line 349 "ptlang.y"
{ clearMethodDefs(0);;
    break;}
case 46:
#line 350 "ptlang.y"
{ clearMethodDefs(M_PURE);;
    break;}
case 47:
#line 351 "ptlang.y"
{ clearMethodDefs(M_VIRTUAL);;
    break;}
case 48:
#line 352 "ptlang.y"
{ clearMethodDefs(M_STATIC);;
    break;}
case 49:
#line 353 "ptlang.y"
{ clearMethodDefs(M_STATIC|M_INLINE);;
    break;}
case 50:
#line 354 "ptlang.y"
{ int mode = M_INLINE;
					  if (yyvsp[-1]) mode |= M_VIRTUAL;
					  clearMethodDefs(mode);
					;
    break;}
case 51:
#line 361 "ptlang.y"
{ yyval = 0;;
    break;}
case 52:
#line 362 "ptlang.y"
{ yyval = yyvsp[0];;
    break;}
case 53:
#line 366 "ptlang.y"
{ yyval = 0;;
    break;}
case 54:
#line 367 "ptlang.y"
{ yyval = yyvsp[0];;
    break;}
case 55:
#line 372 "ptlang.y"
{ bodyMode = 1;;
    break;}
case 56:
#line 376 "ptlang.y"
{ methKey = C_CONS;;
    break;}
case 57:
#line 377 "ptlang.y"
{ methKey = C_DEST;;
    break;}
case 58:
#line 378 "ptlang.y"
{ methKey = C_BEGIN;;
    break;}
case 59:
#line 379 "ptlang.y"
{ methKey = C_SETUP;;
    break;}
case 60:
#line 380 "ptlang.y"
{ methKey = C_GO;;
    break;}
case 61:
#line 381 "ptlang.y"
{ methKey = C_WRAPUP;;
    break;}
case 62:
#line 382 "ptlang.y"
{ methKey = C_INITCODE;;
    break;}
case 63:
#line 383 "ptlang.y"
{ methKey = C_EXECTIME;;
    break;}
case 64:
#line 385 "ptlang.y"
{ yywarn("start is obsolete, use setup");
		  methKey = C_SETUP;
		;
    break;}
case 65:
#line 395 "ptlang.y"
{ char b[SMALLBUFSIZE];
                  objVer = yyvsp[-15];
                  sprintf(b, "\"%s/%s/%s %s:%s:%s\"", yyvsp[-10], yyvsp[-8], yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1]);
                  objDate = save(b);
                ;
    break;}
case 66:
#line 402 "ptlang.y"
{
                  char b[SMALLBUFSIZE];
                  long t;
                  objVer = "?.?";
                  t = time((time_t *)0);
                  b[0] = QUOTE;
                  strncat(b,ctime(&t),24);
                  strcat(b,"\"");
                  objDate = save(b);
                ;
    break;}
case 67:
#line 416 "ptlang.y"
{ char b[SMALLBUFSIZE];
		  objVer = yyvsp[-5];
		  sprintf(b, "\"%s/%s/%s\"", yyvsp[-4], yyvsp[-2], yyvsp[0]);
		  objDate = save(b);
		;
    break;}
case 68:
#line 425 "ptlang.y"
{ char b[SMALLBUFSIZE];
		  objVer = yyvsp[-3];
		  sprintf(b, "\"%s %s %s\"", yyvsp[-2], yyvsp[-1], yyvsp[0]);
		  objDate = save(b);
		;
    break;}
case 69:
#line 432 "ptlang.y"
{ char b[SMALLBUFSIZE];
		  objVer = yyvsp[-5];
		  sprintf(b, "\"%s/%s/%s\"", yyvsp[-4], yyvsp[-2], yyvsp[0]);
		  objDate = save(b);
		;
    break;}
case 70:
#line 438 "ptlang.y"
{
		  char b[SMALLBUFSIZE];
		  long t;
		  objVer = "?.?";
		  t = time((time_t *)0);
		  b[0] = QUOTE;
		  strncat(b,ctime(&t),24);
		  strcat(b,"\"");
		  objDate = save(b);
		  /* objDate = "\"checked out\""; */
		;
    break;}
case 71:
#line 449 "ptlang.y"
{ yyerror("Illegal version format");;
    break;}
case 73:
#line 456 "ptlang.y"
{ domain = yyvsp[-1];;
    break;}
case 74:
#line 457 "ptlang.y"
{ derivedFrom = yyvsp[-1];;
    break;}
case 75:
#line 458 "ptlang.y"
{ genPort();
					  describePort(); ;
    break;}
case 76:
#line 461 "ptlang.y"
{ char* b = malloc(SMALLBUFSIZE);
					  blockID = yyvsp[-3];
					  strcpy(b,blockID);
					  codeBlockNames[numBlocks]=b;
					  codeBlockArgs[numBlocks]=save(yyvsp[-2]);
					  codeBlockLines[numBlocks]=
					    savelineref();
					  codeMode = 1;
					;
    break;}
case 77:
#line 470 "ptlang.y"
{ codeBlocks[numBlocks++]=yyvsp[0];
					  codeMode = 0;
					;
    break;}
case 78:
#line 475 "ptlang.y"
{ yyval = (char*)0; ;
    break;}
case 79:
#line 476 "ptlang.y"
{ yyval = stripQuotes(yyvsp[0]); ;
    break;}
case 80:
#line 480 "ptlang.y"
{ bodyMode = 1;;
    break;}
case 85:
#line 494 "ptlang.y"
{ methodName = yyvsp[-1];;
    break;}
case 86:
#line 495 "ptlang.y"
{ methodArgs = checkArgs(yyvsp[-1]);;
    break;}
case 87:
#line 496 "ptlang.y"
{ methodType = yyvsp[-1];;
    break;}
case 88:
#line 497 "ptlang.y"
{ methodAccess = yyvsp[-1];;
    break;}
case 89:
#line 498 "ptlang.y"
{ methodCode = yyvsp[0]; bodyMode = 0;;
    break;}
case 90:
#line 503 "ptlang.y"
{ bodyMode = 1;;
    break;}
case 91:
#line 508 "ptlang.y"
{ bodyMode = 1;;
    break;}
case 92:
#line 513 "ptlang.y"
{ bodyMode = 1; yyval = yyvsp[-1];;
    break;}
case 97:
#line 526 "ptlang.y"
{ genInstance();;
    break;}
case 98:
#line 527 "ptlang.y"
{ genAlias();;
    break;}
case 99:
#line 536 "ptlang.y"
{ initPort(0,0);;
    break;}
case 100:
#line 537 "ptlang.y"
{ initPort(1,0);;
    break;}
case 101:
#line 538 "ptlang.y"
{ initPort(2,0);;
    break;}
case 102:
#line 539 "ptlang.y"
{ initPort(0,1);;
    break;}
case 103:
#line 540 "ptlang.y"
{ initPort(1,1);;
    break;}
case 104:
#line 541 "ptlang.y"
{ initPort(2,1);;
    break;}
case 107:
#line 550 "ptlang.y"
{ portName = yyvsp[-1];;
    break;}
case 108:
#line 551 "ptlang.y"
{ portType = portDataType(yyvsp[-1]);;
    break;}
case 109:
#line 552 "ptlang.y"
{ portInherit = yyvsp[-1];;
    break;}
case 110:
#line 553 "ptlang.y"
{ portNum = yyvsp[-1];;
    break;}
case 111:
#line 554 "ptlang.y"
{ portAttrib = yyvsp[0]; bodyMode = 0;;
    break;}
case 112:
#line 555 "ptlang.y"
{ descMode = 1; docMode = 1;;
    break;}
case 113:
#line 555 "ptlang.y"
{ portDesc = yyvsp[0]; docMode = 0;
					  descMode = 0;;
    break;}
case 116:
#line 566 "ptlang.y"
{ stateName = yyvsp[-1];;
    break;}
case 117:
#line 567 "ptlang.y"
{ int tc = stateTypeClass(yyvsp[-1]);
					  stateMarks[tc]++;
					  stateClass = stateClasses[tc];
					;
    break;}
case 118:
#line 571 "ptlang.y"
{ stateDef = yyvsp[-1];;
    break;}
case 119:
#line 572 "ptlang.y"
{ descMode = 1; docMode = 1;;
    break;}
case 120:
#line 573 "ptlang.y"
{ stateDesc = yyvsp[0];
					  docMode = 0;
					  descMode = 0;;
    break;}
case 121:
#line 576 "ptlang.y"
{ stateAttrib = yyvsp[0]; bodyMode=0;;
    break;}
case 122:
#line 579 "ptlang.y"
{ bodyMode=1;;
    break;}
case 123:
#line 582 "ptlang.y"
{ yyval = yyvsp[0];;
    break;}
case 124:
#line 583 "ptlang.y"
{ char b[SMALLBUFSIZE];
					  sprintf (b, "\"%s\"", yyvsp[0]);
					  yyval = save(b);
					;
    break;}
case 125:
#line 587 "ptlang.y"
{ char b[SMALLBUFSIZE];
					  sprintf (b, "\"%s\"", yyvsp[0]);
					  yyval = save(b);
					;
    break;}
case 126:
#line 593 "ptlang.y"
{ yyval = save(yyvsp[0]);;
    break;}
case 127:
#line 594 "ptlang.y"
{ char* b = malloc(MEDBUFSIZE);
					  strcpy(b,yyvsp[-1]);
					  strcat(b," ");
					  strcat(b,yyvsp[0]);
					  yyval = b; ;
    break;}
case 128:
#line 602 "ptlang.y"
{ yyval = yyvsp[0];;
    break;}
case 129:
#line 603 "ptlang.y"
{ char b[SMALLBUFSIZE];
					  strcpy (b, yyvsp[0]+1);
					  b[strlen(yyvsp[0])-2] = 0;
					  yyval = save(b);
					;
    break;}
case 132:
#line 616 "ptlang.y"
{ instName = yyvsp[-1];;
    break;}
case 133:
#line 617 "ptlang.y"
{ instClass = yyvsp[-1];;
    break;}
case 136:
#line 626 "ptlang.y"
{ galPortName = yyvsp[-1];;
    break;}
case 138:
#line 631 "ptlang.y"
{ checkIncludes(nCcInclude-1); 
					  ccInclude[nCcInclude++] = yyvsp[0];;
    break;}
case 140:
#line 637 "ptlang.y"
{ checkSeeAlsos(nSeeAlso-1);
					  seeAlsoList[nSeeAlso++] = yyvsp[0];;
    break;}
case 142:
#line 642 "ptlang.y"
{ checkIncludes(nHInclude-1); 
					  hInclude[nHInclude++] = yyvsp[0];;
    break;}
case 147:
#line 655 "ptlang.y"
{ yyval = stripQuotes (yyvsp[0]);;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/users/ptolemy/gnu/common/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 669 "ptlang.y"


/*****************************************************************************
 *
 *			C functions
 *
 * These are 3 classes of functions in this section:
 * 
 * 1. Utility functions called by the grammar (above) to store away
 *    pieces of data.
 * 2. "Generation" functions that write out all the data we've collected
 *    to produce the .h, .cc, and doc files.
 * 3. The yacc driver and lexer.
 *
 *****************************************************************************/

/* Reset for a new star or galaxy class definition.  If arg is TRUE
   we are defining a galaxy.
 */
void clearDefs (g)
int g;
{
	int i;
	for (i = 0; i < NSTATECLASSES; i++) stateMarks[i] = 0;
	galDef = g;
	objName = objVer = objDesc = domain = derivedFrom =
		objAuthor = objCopyright = objExpl = objLocation = NULL;
	consStuff[0] = ccCode[0] = hCode[0] = consCalls[0] = 0;
	publicMembers[0] = privateMembers[0] = protectedMembers[0] = 0;
	inputDescriptions[0] = outputDescriptions[0] = inoutDescriptions[0] = 0;
	stateDescriptions[0] = 0;
	nCcInclude = nHInclude = nSeeAlso = 0;
	pureFlag = 0;
	for (i = 0; i < N_FORMS; i++) {
		codeBody[i] = 0;
		inlineFlag[i] = 0;
	}
}

/* Generate a state definition */
void clearStateDefs ()
{
	stateName = stateClass = stateDef = stateDesc = stateAttrib = NULL;
}

char*
cvtToLower (name)
char* name;
{
	static char buf[128];
	char* p = buf, c;
	while ((c = *name++) != 0) {
		if (isupper(c)) *p++ = tolower(c);
		else *p++ = c;
	}
	*p = 0;
	return buf;
}

char*
cvtToUpper (name)
char* name;
{
	static char buf[128];
	char* p = buf, c;
	while ((c = *name++) != 0) {
		if (islower(c)) *p++ = toupper(c);
		else *p++ = c;
	}
	*p = 0;
	return buf;
}


char* whichMembers (type)
char* type;
{
/* type must be "protected", "public", or "private" */
	switch (type[2]) {
	case 'o':
		return protectedMembers;
	case 'b':
		return publicMembers;
	case 'i':
		return privateMembers;
	default:
		fprintf (stderr, "Internal error in whichMembers\n");
		exit (1);
		/* NOTREACHED */
	}
}

/* add declarations of extra members to the class definition */
void addMembers (type, defs)
char* type;
char* defs;
{
	char * p = whichMembers (type);
	strcat (p, defs);
	strcat (p, "\n");
	return;
}

/* get "real" state class name from an argument */
int
stateTypeClass (nameArg)
char* nameArg;
{
	char* name = cvtToLower (nameArg);
 
	if (strcmp (name, "int") == 0)
		return T_INT;
	if (strcmp (name, "float") == 0)
		return T_FLOAT;
	if (strcmp (name, "complex") == 0)
		return T_COMPLEX;
	if (strcmp (name, "string") == 0)
		return T_STRING;
	if (strcmp (name, "intarray") == 0)
		return T_INTARRAY;
	if (strcmp (name, "floatarray") == 0)
		return T_FLOATARRAY;
	if (strcmp (name, "complexarray") == 0)
		return T_COMPLEXARRAY;
	if (strcmp (name, "fix") == 0)
		return T_FIX;
	if (strcmp (name, "fixarray") == 0)
		return T_FIXARRAY;
	if (strcmp (name, "stringarray") == 0)
		return T_STRINGARRAY;
	if (strcmp (name, "precision") == 0)
		return T_PRECISION;
	fprintf (stderr, "state class %s\n", name);
	yyerror ("bad state class: assuming int");
		return T_INT;
}

/* generate code for a state defn */
void genState ()
{
	char* stateDescriptor;
	char* stateDefault;
	/* test that all fields are known */
	if (stateName == NULL) {
		yyerror ("state name not defined");
		return;
	}
	if (stateClass == NULL) {
		yyerror ("state class not defined");
		return;
	}
	if (stateDef == NULL)
		stateDefault = "\"\"";
	else
		stateDefault = stateDef;
	if (stateDesc == NULL)
		stateDescriptor = stateName;
	else
		stateDescriptor = stateDesc;
	sprintf (str1,"\t%s %s;\n", stateClass, stateName);
	sprintf (str2,"\taddState(%s.setState(\"%s\",this,%s,\"%s\"",
		 stateName, stateName, stateDefault, stateDescriptor);
	if (stateAttrib) {
		strcat (str2, ",\n");
		strcat (str2, stateAttrib);
	}
	strcat (str2, "));\n");
	strcat (protectedMembers, str1);
	strcat (consStuff, str2);
}

/* describe the states */
void describeState ()
{
	char descriptString[MEDBUFSIZE];

	sprintf(str1,".NE\n\\fI%s\\fR (%s)",stateName,stateClass);
	strcat(stateDescriptions,str1);
	if (stateDesc) {
	    if(unescape(descriptString, stateDesc, MEDBUFSIZE))
		yywarn("warning: Descriptor too long. May be truncated.");
	    sprintf(str1,": %s\n",descriptString);
	} else
	    sprintf(str1,"\n");
	strcat(stateDescriptions,str1);
	if (stateDef) {
		sprintf(str1,".DF %s\n",stateDef);
	}
	strcat(stateDescriptions,str1);
}

/* set up for port definition */
void initPort (dir, multi)
int dir, multi;
{
	portDir = dir;
	portMulti = multi;
	portName = portNum = portInherit = portDesc = portAttrib = NULL;
	portType = "ANYTYPE";
}

char* portDataType (name)
char* name;
{
	/* do better checking later */
	return save(name);
}

void genPort ()
{
	/* test that all fields are known */
	char* dir = portDir==2 ? "InOut" : (portDir==1?"Out" : "In");
	char* m = portMulti ? "Multi" : "";
	char* d = galDef ? "" : domain;
	char* port = galDef ? "PortHole" : "Port";

	sprintf (str1,"\t%s%s%s%s %s;\n", m, dir, d, port, portName);
	if (portNum)
		sprintf (str2, "\taddPort(%s.setPort(\"%s\",this,%s,%s));\n",
			portName, portName, cvtToUpper(portType), portNum);
	else
		sprintf (str2, "\taddPort(%s.setPort(\"%s\",this,%s));\n",
			portName, portName, cvtToUpper(portType));
	strcat (publicMembers, str1);
	strcat (consStuff, str2);
	if (portAttrib) {
		sprintf (str2, "\t%s.setAttributes(\n%s);\n", portName,
			portAttrib);
		strcat (consStuff, str2);
	}
	if (portInherit) {
		sprintf (str2, "\t%s.inheritTypeFrom(%s);\n", portName,
			 portInherit);
		strcat (consStuff, str2);
	}
}

void describePort ()
{
	char *dest;
	char descriptString[MEDBUFSIZE];
	dest = portDir==2 ? inoutDescriptions 
	  : (portDir==1 ? outputDescriptions : inputDescriptions);
	if (portMulti) {
	    sprintf(str1,".NE\n\\fI%s\\fR (multiple), (%s)",portName,portType);
	} else {
	    sprintf(str1,".NE\n\\fI%s\\fR (%s)",portName,portType);
	}
	strcat(dest,str1);

	if (portDesc) {
	    if(unescape(descriptString, portDesc, MEDBUFSIZE))
		yywarn("warning: Descriptor too long. May be truncated.");
	    sprintf(str1,": %s\n",descriptString);
	} else
	    sprintf(str1,"\n");
	strcat(dest,str1);
}

/* set up for user-supplied method */
void clearMethodDefs (mode)
int mode;
{
	methodName = NULL;
	methodArgs = "()";
	methodAccess = "protected";
	methodCode = NULL;
	methodType = "void";
	methodMode = mode;
}

/* generate code for user-defined method */
void wrapMethod ()
{
	char * p = whichMembers (methodAccess);
	char * mkey = "";
/* add decl to class body */
	if (methodMode == M_PURE) {
		if (methodCode) yyerror ("Code supplied for pure method");
		/* pure virtual function case */
		sprintf (str1, "\tvirtual %s %s %s = 0;\n",
			methodType, methodName, methodArgs);
		strcat (p, str1);
		pureFlag++;
		return;
	}
	if (methodCode == NULL) {
		yyerror ("No code supplied for method");
		methodCode = "";
	}
	/* form declaration in class body */
	if (methodMode & M_STATIC) mkey = "static ";
	else if (methodMode & M_VIRTUAL) mkey = "virtual ";
	sprintf (str1, "\t%s%s %s %s", mkey, methodType,
		 methodName, methodArgs);
	strcat (p, str1);
	/* handle inline functions */
	if (methodMode & M_INLINE) {
		strcat (p, " {\n");
		strcat (p, methodCode);
		strcat (p, "\n\t}\n");
		return;
	}
	/* not inline: put it into the .cc file */
	strcat (p, ";\n");
	sprintf (str2, "\n\n%s %s%s::%s ", methodType,
		 galDef ? "" : domain, objName, methodName);
	strcat (miscCode, str2);
	stripDefaultArgs (str2, methodArgs);
	strcat (miscCode, str2);
	strcat (miscCode, "\n{\n");
	strcat (miscCode, methodCode);
	strcat (miscCode, "\n}\n");
}

/* generate an instance of a block within a galaxy */
void genInstance ()
{
	sprintf (str1, "\t%s %s;\n", instClass, instName);
	strcat (protectedMembers, str1);
	sprintf (str2,"addBlock(%s.setBlock(\"%s\",this)", instName, instName);
	strcat (consStuff, str2);
}


void genAlias () {
	/* FILL IN */
}

void genConnect () {
	/* FILL IN */
}



/* fn to write out standard methods in the header */
void genStdProto(fp,i)
FILE* fp;
int i;
{
	if (codeBody[i])
		fprintf (fp, "\t/* virtual */ %s%s()%s\n", codeType[i],
			 codeFuncName[i], inlineFlag[i] ? " {" : ";");
	if (inlineFlag[i])
		fprintf (fp, "%s\n\t}\n", codeBody[i]);
}

/* return true if the n characters beginning at s are whitespace. */
static int
isStrnSpace( s, n)
    char	*s;
    int		n;
{
    int		c;

    for (; n > 0; n--, s++) {
	c = *s;
	if ( c!=' ' && c!='\t' )
	    return 0;
    }


    return 1;
}


void cvtCodeBlockExpr( src, src_len, pDst)
    char *src, **pDst;
    int src_len;
{
    char *dst = *pDst;

    /*IF*/ if ( src_len==6 && strncmp(src,"ATSIGN",6)==0 ) {
	*dst++ = '@';		/* */
    } else if ( src_len==6 && strncmp(src,"LBRACE",6)==0 ) {
	*dst++ = '{';		/* } (to balance 'vi') */
    } else if ( src_len==6 && strncmp(src,"RBRACE",6)==0 ) {
	/* { (to balance 'vi') */
	*dst++ = '}';
    } else if ( src_len==9 && strncmp(src,"BACKSLASH",9)==0 ) {
	*dst++ = '\\';
    } else if ( isStrnSpace( src, src_len) ) {
	; /* just drop it */
    } else {
	strcpy(dst,"\" << ("); dst += strlen(dst);
	strncpy( dst, src, src_len); dst += src_len;
	strcpy(dst,") << \""); dst += strlen(dst);
    }
    *pDst = dst;
}

/**
    Convert a codeblock.  If extendB is FALSE, a set of string literals
    will be produced, with the contents of {src} escaped into proper C
    strings.  If extendB is TRUE, The ``@'' substitutions below will
    be processed and merged with the string literals using the "<<" syntax.
    Syntax rules:
	@@	==> @			(double ``@'' goes to single)
	@LBRACE ==> {			(LBRACE is literal string)
	@RBRACE ==> }			(RBRACE is literal string)
	@id	==> C++ token {id}	(id is one or more alphanumerics)
	@(expr) ==> C++ expr {expr}	(expr is arbitrary with balanced parens)
        @anything_else is passed through unchanged (including the @).
    If extendB is FALSE, then none of the ``@'' process occurs.

    The above list is prob. out of date.
**/
void cvtCodeBlock( src_in, dst_in, extendB)
    char *src_in, *dst_in;
    int extendB;
{
    char	*src = src_in, *dst = dst_in;
    char	*src_expr;
    int		c, parenCnt;

    *dst++ = QUOTE;
    for (; (c = *src++) != '\0'; ) {
	switch ( c ) {
	case ESC:
	    c = *src;
	    if ( extendB && c == '\n' ) {
		++src;	/* strip the newline */
	    } else if ( extendB && c == '\0' ) {
		; /* nothing */
	    } else {
		/* one backslash in input becomes two in output */
		*dst++ = ESC;
		*dst++ = ESC;
	    }
	    break;
	case QUOTE:
	    *dst++ = ESC;
	    *dst++ = QUOTE;
	    break;
	case NEWLINE:
	    *dst++ = ESC; *dst++ = 'n';
	    if ( *src == '\0' )	break;
	    *dst++ = '"'; *dst++ = NEWLINE; *dst++ = '"';
	    break;
	case '@':
	    if ( ! extendB ) {
		*dst++ = c;
		break;
	    }
	    c = *src++;
	    /*IF*/ if ( c=='@' || c=='\\' || c=='{' || c=='}' ) {
		*dst++ = c;
	    } else if ( c == '(' ) {
		for ( src_expr=src, parenCnt=1; parenCnt > 0; ) {
		    c = *src++;
		    /*IF*/ if ( c=='\0' ) {
			fprintf(stderr,"Unbalanced parans in @() codeblock\n");
			exit(1);
		    } else if ( c=='(' ) {
			++parenCnt;
		    } else if ( c==')' ) {	
		        if ( --parenCnt == 0 )
			    break;
		    }
		}
		cvtCodeBlockExpr( src_expr, src-src_expr-1, &dst);
	    } else if ( isalpha(c) ) {
		    for ( src_expr=src-1; c=*src++, isalnum(c); )
			;
		    cvtCodeBlockExpr( src_expr, src-src_expr-1, &dst);
		    --src;	/* for() loop will advance */
	    } else {
	        *dst++ = '@';
		*dst++ = c;
	    }
	    break;
	default:
	    *dst++ = c;
	}
    }
    *dst++ = QUOTE;
    *dst = '\0';
}


void genCodeBlock( fp, src, extendB)
    FILE *fp;
    char *src;
    int extendB;
{
    char *dst = malloc(strlen(src)*2+MEDBUFSIZE);
    cvtCodeBlock( src, dst, extendB);
    fputs( dst, fp);
    free(dst);
}


/**
    Convert a method body (standard (e.g., go) or custom).  Primarily
    involves processing for in-line codeblocks.
    Lines starting with a "@" will have the leading white-space striped,
    and the remainder of the line processed by cvtCodeBlock(),
    with the result added to the default code stream.
**/
void cvtMethod( src_in, dst_in)
    char *src_in, *dst_in;
{
    char	*src = src_in, *dst = dst_in;
    char	*src_line, *src_start, *src_end;
    int		c, c_end;
    int		codeblockB = 0;

    for (; *src!='\0' || codeblockB; ) {
	src_line = src;
	for ( ; (c=*src++) != '\0' && isspace(c) && c!=NEWLINE; )
	    ;
	src_start = --src;
	for ( ; (c=*src++) != '\0' && c!=NEWLINE; )
	    ;
	src_end = c==NEWLINE ? src : --src;
	c_end = *src_end; *src_end = '\0';
	if ( src_start[0] == '@' ) {
	    src = src_start+1;
	    if ( !codeblockB ) {
		codeblockB = 1;
	        strcpy(dst, "\t{ StringList _str_; _str_ << \n");
		dst+=strlen(dst);
	    }
	    cvtCodeBlock( src, dst, 1);		dst+=strlen(dst);
	    *dst++ = NEWLINE;
	} else {
	    if ( codeblockB ) {
	        strcpy(dst, ";\n\t addCode(_str_); }\n"); dst+=strlen(dst);
		codeblockB = 0;
	    }
	    strcpy( dst, src_line); dst += strlen(dst);
	}
	*src_end = c_end;
	src = src_end;
    }
    *dst = '\0';
}

void genMethod( fp, src)
    FILE *fp;
    char *src;
{
    char *dst = malloc(strlen(src)*2+MEDBUFSIZE);
    cvtMethod( src, dst);
    fputs( dst, fp);
    free(dst);
}

/* This is the main guy!  It outputs the complete class definition. */
void genDef ()
{
	FILE *fp;
	int i;
	char fname[FLEN], hname[FLEN], ccname[FLEN];
	char baseClass[SMALLBUFSIZE];
	char fullClass[SMALLBUFSIZE];
	char descriptString[MEDBUFSIZE];

/* temp, until we implement this */
	if (galDef) {
		fprintf (stderr, "Sorry, galaxy definition is not yet supported.\n");
		exit (1);
	}
	if (objName == NULL) {
		yyerror ("No class name defined");
		return;
	}
	if (!galDef && !domain) {
		yyerror ("No domain name defined");
		return;
	}
	sprintf (fullClass, "%s%s", galDef ? "" : domain, objName);

/***************************************************************************
			CREATE THE .h FILE
*/
	sprintf (hname, "%s.h", fullClass);
	if ((fp = fopen (hname, "w")) == 0) {
		perror (hname);
		exit (1);
	}
/* Surrounding ifdef stuff */
	fprintf (fp, "#ifndef _%s_h\n#define _%s_h 1\n", fullClass, fullClass);
	fprintf (fp, "// header file generated from %s by %s\n",
		 inputFile, progName);

/* Special GNU pragmas for increased efficiency */
	fprintf (fp, "\n#ifdef __GNUG__\n#pragma interface\n#endif\n\n");

/* copyright */
	if (objCopyright) {
	    if ( strncasecmp(objCopyright,"copyright",9)==0 ) {
		fprintf (fp, "/*\n%s\n */\n", objCopyright);
	    } else {
		fprintf (fp, "/*\n * copyright (c) %s\n */\n", objCopyright);
	    }
	}

/* ID block */
	if (idBlock)
		fprintf (fp, "%s\n", idBlock);
/* The base class */
/* For stars, we append the domain name to the beginning of the name,
   unless it is already there */
	if (derivedFrom) {
		if (domain &&
		    strncmp (domain, derivedFrom, strlen (domain)) != 0) {
			sprintf (baseClass, "%s%s", galDef ? "" : domain,
				 derivedFrom);
		}
		else
			(void) strcpy (baseClass, derivedFrom);
	}
/* Not explicitly specified: baseclass is Galaxy or XXXStar */
	else if (galDef)
		(void)strcpy (baseClass, "Galaxy");
	else
		sprintf (baseClass, "%sStar", domain);

/* Include files */
	fprintf (fp, "#include \"%s.h\"\n", baseClass);
	
	checkIncludes(nHInclude);
	for (i = 0; i < nHInclude; i++) {
		fprintf (fp, "#include %s\n", hInclude[i]);
	}
/* Include files for states */
	for (i = 0; i < NSTATECLASSES; i++)
		if (stateMarks[i])
			fprintf (fp, "#include \"%s.h\"\n", stateClasses[i]);

/* extra header code */
	fprintf (fp, "%s\n", hCode);
/* The class template */
	fprintf (fp, "class %s : public %s\n{\n", fullClass, baseClass);
	sprintf (destNameBuf, "~%s", fullClass);
	fprintf (fp, "public:\n\t%s();\n", fullClass);
/* The makeNew function: only if the class isn't a pure virtual */
	if (!pureFlag)
		fprintf (fp, "\t/* virtual */ Block* makeNew() const;\n");
        fprintf (fp, "\t/* virtual*/ const char* className() const;\n");
        fprintf (fp, "\t/* virtual*/ int isA(const char*) const;\n");
/* The code blocks */
	for (i=0; i<numBlocks; i++) {
		if ( codeBlockArgs[i] == NULL ) {
		    fprintf (fp, "\tstatic CodeBlock %s;\n",codeBlockNames[i]);
		} else {
		    fprintf (fp, "\tconst char* %s(%s);\n",
		      codeBlockNames[i], codeBlockArgs[i]);
		}
	}
	for (i = C_EXECTIME; i <= C_DEST; i++)
		genStdProto(fp,i);
	if (publicMembers[0])
		fprintf (fp, "%s\n", publicMembers);
	fprintf (fp, "protected:\n");
	for (i = C_SETUP; i < N_FORMS; i++)
		genStdProto(fp,i);
	if (protectedMembers[0])
		fprintf (fp, "%s\n", protectedMembers);
	if (privateMembers[0])
		fprintf (fp, "private:\n%s\n", privateMembers);
/* that's all, end the class def and put out an #endif */
	fprintf (fp, "};\n#endif\n");
	(void) fclose (fp);

/**************************************************************************
		CREATE THE .cc FILE
*/
	sprintf (ccname, "%s.cc", fullClass);
	if ((fp = fopen (ccname, "w")) == 0) {
		perror (ccname);
		exit (1);
	}
	fprintf (fp, "static const char file_id[] = \"%s\";\n", inputFile);
	fprintf (fp, "// .cc file generated from %s by %s\n",
		 inputFile, progName);
/* copyright */
	if (objCopyright) {
	    if ( strncasecmp(objCopyright,"copyright",9)==0 ) {
		fprintf (fp, "/*\n%s\n */\n", objCopyright);
	    } else {
		fprintf (fp, "/*\n * copyright (c) %s\n */\n", objCopyright);
	    }
	}

/* special GNU pragma for efficiency */
	fprintf (fp, "\n#ifdef __GNUG__\n#pragma implementation\n#endif\n\n");

/* ID block */
	if (idBlock)
		fprintf (fp, "%s\n", idBlock);
/* include files */
	fprintf (fp, "#include \"%s.h\"\n", fullClass);
	for (i = 0; i < nCcInclude; i++)
		fprintf (fp, "#include %s\n", ccInclude[i]);
/* generate className and (optional) makeNew function */
/* also generate a global identifier with name star_nm_DDDNNN, where DDD is
   the domain and NNN is the name */
	fprintf (fp, "\nconst char *star_nm_%s = \"%s\";\n", fullClass, fullClass);
        fprintf (fp, "\nconst char* %s :: className() const {return star_nm_%s;}\n",
		fullClass, fullClass);
	fprintf (fp, "\nISA_FUNC(%s,%s);\n",fullClass,baseClass);
	if (!pureFlag) {
		fprintf (fp, "\nBlock* %s :: makeNew() const { LOG_NEW; return new %s;}\n",
			 fullClass, fullClass);
	}
/* generate the CodeBlock constructor calls */
	for (i=0; i<numBlocks; i++) {
	    if ( codeBlockArgs[i] == NULL ) {
		fprintf (fp, "\nCodeBlock %s :: %s (\n%s\n",
			fullClass,codeBlockNames[i],codeBlockLines[i]);
		genCodeBlock( fp, codeBlocks[i], 0);
		fprintf (fp, ");\n");
	    } else {
		fprintf (fp, "\nconst char* %s :: %s(%s) {\n%s\n",
			fullClass,codeBlockNames[i],codeBlockArgs[i],
			codeBlockLines[i]);
		fprintf (fp, "\tstatic StringList _str_; _str_.initialize(); _str_ << \n");
		genCodeBlock( fp, codeBlocks[i], 1);
		fprintf (fp, ";\n\treturn (const char*)_str_;\n}\n");
	    }
	}
/* prefix code and constructor */
	fprintf (fp, "\n%s%s::%s ()", ccCode, fullClass, fullClass);
	if (consCalls[0])
		fprintf (fp, " :\n\t%s", consCalls);
	fprintf (fp, "\n{\n");
	if (objDesc)
		fprintf (fp, "\tsetDescriptor(\"%s\");\n", objDesc);
	/* define the class name */
	if (!consCode) consCode = "";
	fprintf (fp, "%s\n%s\n", consStuff, consCode);
	fprintf (fp, "}\n");
	for (i = 1; i < N_FORMS; i++) {
		if (codeBody[i] && !inlineFlag[i]) {
		    char *dst = malloc(2*strlen(codeBody[i])+MEDBUFSIZE);
		    cvtMethod( codeBody[i], dst);
		    fprintf (fp, "\n%s%s::%s() {\n%s\n}\n",
		      codeType[i], fullClass, codeFuncName[i], dst);
		    free(dst);
		}
	}
	if (miscCode[0])
		fprintf (fp, "%s\n", miscCode);
	if (pureFlag) {
		fprintf (fp,
			 "\n// %s is an abstract class: no KnownBlock entry\n",
			 fullClass);
	}
	else {
		fprintf (fp, "\n// prototype instance for known block list\n");
		fprintf (fp, "static %s proto;\n", fullClass);
		fprintf (fp, "static RegisterBlock registerBlock(proto,\"%s\");\n",
			 objName);
	}
	(void) fclose(fp);

/**************************************************************************
		CREATE THE DOCUMENTATION FILE
*/

	sprintf (fname, "%s.t", fullClass);
	if ((fp = fopen (fname, "w")) == 0) {
		perror (fname);
		exit (1);
	}

	/* Turn eqn delimitters off */
	fprintf (fp, ".EQ\ndelim off\n.EN\n");

	fprintf (fp, ".\\\" documentation file generated from %s by %s\n",
		 inputFile, progName);

/* copyright */
	if (objCopyright) {
		char* p = objCopyright;
		while (*p) {
			/* make each line a comment */
			fprintf (fp, ".\\\" ");
			while (*p && *p != NEWLINE) fputc(*p++,fp);
			if (*p == NEWLINE) fputc(*p++,fp);
		}
		fputc(NEWLINE,fp);
	}

/* Name */
	fprintf (fp, ".NA \"%s\"\n", objName);

/* short descriptor */
	fprintf (fp, ".SD\n");
	if (objDesc) {
		/*
		 * print descriptor with "\n" replaced with NEWLINE,
		 * and "\t" replaced with a tab.
		 * Any other escaped character will be printed as is.
		 */
		if(unescape(descriptString, objDesc, MEDBUFSIZE))
		    yywarn("warning: Descriptor too long. May be truncated.");
		fprintf (fp, "%s\n", descriptString);
	}
	fprintf (fp, ".SE\n");

/* location */
	if (objLocation)
		fprintf (fp, ".LO \"%s\"\n",objLocation);

/* base class and domain */
	/* For stars, we append the domain name to the beginning of the name,
	   unless it is already there */
	if (derivedFrom) {
		if (domain &&
		    strncmp (domain, derivedFrom, strlen (domain)) != 0) {
			sprintf (baseClass, "%s%s", galDef ? "" : domain,
				 derivedFrom);
		}
		else
			(void) strcpy (baseClass, derivedFrom);
	}
	/* Not explicitly specified: baseclass is Galaxy or XXXStar */
	else if (galDef)
		(void)strcpy (baseClass, "Galaxy");
	else
		sprintf (baseClass, "%sStar", domain);

	fprintf (fp, ".DM %s %s\n", domain, baseClass);

/* version */
	if (objVer && objDate)
		fprintf (fp, ".SV %s %s\n", objVer, objDate);

/* author */
	if (objAuthor)
		fprintf (fp, ".AL \"%s\"\n", objAuthor);

/* acknowledge */
	if (objAcknowledge)
		fprintf (fp, ".AC \"%s\"\n", objAcknowledge);

/* inputs */
	if ((int)strlen(inputDescriptions) > 0)
		fprintf (fp, ".IH\n%s.PE\n", inputDescriptions);

/* outputs */
	if ((int)strlen(outputDescriptions) > 0)
		fprintf (fp, ".OH\n%s.PE\n", outputDescriptions);

/* inouts */
	if ((int)strlen(inoutDescriptions) > 0)
		fprintf (fp, ".BH\n%s.PE\n", inoutDescriptions);

/* states */
	if ((int)strlen(stateDescriptions) > 0)
		fprintf (fp, ".SH\n%s.ET\n", stateDescriptions);

/* explanation */
	/* Turn eqn delimitters on */
	fprintf (fp, ".EQ\ndelim $$\n.EN\n");
	if (objExpl)
		fprintf (fp, ".LD\n%s\n", objExpl);

/* ID block (will appear in .h and .cc files only. */

/* See Also list */
	if (nSeeAlso > 0) fprintf (fp, ".SA\n");
	if (nSeeAlso > 2) {
	    checkSeeAlsos(nSeeAlso);
	    for (i = 0; i < (nSeeAlso - 2); i++)
		fprintf (fp, "%s,\n", seeAlsoList[i]);
	}
	if (nSeeAlso > 1) fprintf (fp, "%s and\n", seeAlsoList[nSeeAlso-2]);
	if (nSeeAlso > 0) fprintf (fp, "%s.\n", seeAlsoList[nSeeAlso-1]);

/* end the final entry */
	fprintf (fp, ".ES\n");

/* close the file */
	(void) fclose (fp);
}



struct tentry {
	char* key;
	int code;
};

/* keyword table */
struct tentry keyTable[] = {
	{"access", ACCESS},
	{"acknowledge", ACKNOWLEDGE},
	{"alias", ALIAS},
	{"arglist", ARGLIST},
	{"attrib", ATTRIB},
	{"attributes", ATTRIB},
	{"author", AUTHOR},
	{"begin", BEGIN},
	{"ccinclude", CCINCLUDE},
	{"class", CLASS},
	{"code", CODE},
	{"codeblock", CODEBLOCK},
	{"conscalls", CONSCALLS},
	{"consCalls", CONSCALLS},
	{"constructor", CONSTRUCTOR},
	{"copyright", COPYRIGHT},
	{"default", DEFAULT},
	{"defstar", DEFSTAR},
	{"defstate", DEFSTATE},
	{"derived", DERIVED},
	{"derivedFrom", DERIVED},
	{"derivedfrom", DERIVED},
	{"desc", DESC},
	{"descriptor", DESC},
	{"destructor", DESTRUCTOR},
	{"domain", DOMAIN},
	{"execTime", EXECTIME},
	{"exectime", EXECTIME},
	{"explanation", EXPLANATION},
	{"galaxy", GALAXY},
	{"go", GO},
	{"header", HEADER},
	{"hinclude", HINCLUDE},
	{"ident", ID},
	{"initCode", INITCODE},
	{"initcode", INITCODE},
	{"inmulti", INMULTI},
	{"inline", INLINE},
	{"inout", INOUT},
	{"inoutmulti", INOUTMULTI},
	{"input", INPUT},
	{"location", LOCATION},
	{"method", METHOD},
	{"name", NAME},
	{"num", NUM},
	{"numports", NUMPORTS},
	{"numTokens", NUM},
	{"numtokens", NUM},
	{"outmulti", OUTMULTI},
	{"output", OUTPUT},
	{"private", PRIVATE},
	{"programmer", AUTHOR},
	{"protected", PROTECTED},
	{"public", PUBLIC},
	{"pure", PURE},
	{"seealso", SEEALSO},
	{"setup", SETUP},
	{"star", STAR},
	{"start", START},
	{"state", DEFSTATE},
	{"static", STATIC},
	{"type", TYPE},
	{"version", VERSION},
	{"virtual", VIRTUAL},
	{"wrapup", WRAPUP},
	{0, 0},
};

int
yyinput() {
    int	c;
    if ( (c=getc(yyin)) == NEWLINE ) {
	++yyline;
    }
    return c;
}


#ifdef notdef
/*
 * In codeMode, we look for LINEs and return them.
 * A LINE is an exact copy of of line of input that
 * does not contain the closing '}'.
 * When a line is encountered that contains the closing '}'
 * that closing '}' is returned.  Anything else on the line is lost.
 */
int
yylexCode_old(pCurChar)
    int *pCurChar;
{
    int		inQuote = 0;
    char	*p = yytext;
    int		c = *pCurChar;
    int		rettok = LINE;

    /* eat spaces until a newline */
    while (c==0 || (isspace(c) && c != NEWLINE))
	c = yyinput();
    /* now eat the newline */
    if (c == NEWLINE) c = yyinput();
    /* now transfer characters to yytext until the next newline,
       or the closing brace. */
    while (c != NEWLINE) {
	*p++ = c;
	switch (c) {
		/* one backslash in input becomes two in output */
	  case ESC:
	    *p++ = c;
	    break;
	  case QUOTE:
	    /* quote in input is escaped */
	    p[-1] = ESC;
	    *p++ = c;
	    inQuote = !inQuote;
	    break;
	  case EOF:
	    yyerror ("Unexpected EOF in body!");
	    exit (1);
	  default:
	    if (!inQuote) {
		if (c == '{') codeModeBraceCount++;
		else if (c == '}') {
		    if ( --codeModeBraceCount == 0 ) {
			/*{*/ rettok = '}';
			c = 0;
			goto done;
		    }
		}
	    }
	}
	c = yyinput();
    }
done:
    /* output doesn't include the NEWLINE or right-brace */
    *pCurChar = c;
    p[0] = 0;
    yylval = save(yytext);
    return rettok;
}

#endif

/*
 * new-style codeMode.  Very much like body-mode: we return an entire
 * multi-line brace-delimined token.  We dont handle ``//'' style comments
 * (or any comments, for that matter).
 */
int
yylexCode(pCurChar)
    int *pCurChar;
{
    int		inQuote = 0;
    char	*p = yytext;
    int		c = *pCurChar;
    int		brace = 1;
    int		startLine = yyline;
    int		startQLine = yyline;

    /* eat spaces until a newline */
    while (c==0 || (isspace(c) && c != NEWLINE))
	c = yyinput();
    /* now eat the newline */
    if (c == NEWLINE) c = yyinput();
    /* now transfer characters to yytext until the next newline,
       or the closing brace. */
    while (1) {
	*p++ = c;
	switch (c) {
#ifdef notdef
	case ESC:
	    c = yyinput();
	    *p++ = c;
	    break;
#endif
	case EOF:
	    sprintf(yytext, "Unterminated %s: it began on line %d",
	     inQuote ? "codeblock string" : "codeblock",
	     inQuote ? startQLine : startLine);
	    yyerror(yytext);
	    exit(1);
	case QUOTE:
	    inQuote = !inQuote;
	    startQLine = yyline;
	    break;
	case '{':
	    if ( inQuote )	break;
	    ++brace;
	    break;
	case '}':
	    if ( inQuote )	break;
	    if ( --brace == 0 ) {
		/* strip last brace and white space up to but not including
		 * the last newline.  (e.g., last char will be newline)
		 */
		*--p = ' ';
		for ( ; p>yytext && isspace(*p) && *p!=NEWLINE; --p)
		    ;
		*++p = 0;
		*pCurChar = 0;
		yylval = save(yytext);
		return BODY;
	    }
	    break;
	}
	c = yyinput();
    }
}




/* bodyMode causes a whole function or document
 * body to be returned as a single token.
 * Leading and trailing spaces are removed
 */
int
yylexBody(pCurChar)
    int *pCurChar;
{
    int		c = *pCurChar;
    char*	p = yytext;
    int		brace = 1;
    int		inQuote = 0;
    int		inComment = 0;
    int		inAt = 0, inAtNext = 0;
    int		startLine = yyline;
    int		startQLine = yyline;

    /* if !docMode, put a "#line" directive in the token */
    if (!docMode) {
	sprintf(p, "# line %d \"%s\"\n", yyline, inputFile);
	p += strlen(p);
    }

    while (brace > 0) {
	*p++ = c;
	switch (c) {
	case ESC:
	    c = yyinput();
	    *p++ = c;
	    break;
	case QUOTE:
	    if (!inComment) {
		    inQuote = !inQuote;
		    startQLine = yyline;
	    }
	    break;
	case EOF:
	    sprintf (yytext,
	      "Unterminated %s at EOF: it began on line %d",
	      inQuote ? "string" : "body block",
	      inQuote ? startQLine : startLine);
	    yyerror(yytext);
	    exit(1);
	case '/':
	    if (inQuote) break;
	    c = getc(yyin);
	    if (c == '/') {
		    inComment = 1;
		    *p++ = c;
	    } else {
		ungetc(c,yyin);
	    }
	    break;
	case NEWLINE:
	    inComment = 0;
	    break;
	default:
	    if (!inQuote && !inComment) {
	       if ( !inAt ) {
		   if (c == '@')	inAtNext = 1;
	           else if (c == '{') brace++;
	           else if (c == '}') brace--;
	       }
	    }
	}
	c = yyinput();
	inAt = inAtNext;
	inAtNext = 0;
    }
    /* The BODY token does not include the closing '}' though it is removed
     * from the input.
     */
    --p;
    /* trim trailing whitespace */
    --p;
    while (isspace(*p)) --p;
    p[1] = 0;
    yylval = save(yytext);
    *pCurChar = 0;
    return BODY;
}

/**
    Return an entire descriptor.
    descMode causes a whole descriptor body to be returned as a single token
    in the form of a string with newlines indicated as "\n" and quotes
    escaped (\").
**/
int
yylexDesc(pCurChar)
    int *pCurChar;
{
    int		c = *pCurChar;
    char*	p = yytext;
    int		brace = 1;
    int		inQuote = 0;
    while (brace > 0) {
	*p++ = c;
	switch (c) {
	case ESC:
		c = yyinput();
		*p++ = c;
		break;
	case QUOTE:
		/* escape the quote */
		--p;
		*p++ = ESC;
		*p++ = QUOTE;
		inQuote = !inQuote;
		break;
	case NEWLINE:
		/* replace with "\n" */
		--p;
		*p++ = ESC;
		*p++ = 'n';
		break;
	case EOF:
		yyerror ("Unexpected EOF in descriptor!");
		exit (1);
	default:
		if (!inQuote) {
		  if (c == '{') brace++;
		  else if (c == '}') brace--;
		}
		break;
	}
	c = yyinput();
    }
   /* The BODY token does not include the closing '}' though it is removed
    * from the input.
    */
    --p;
    /* trim trailing whitespace or '\n' */
    --p;
    while (isspace(*p) || (*p == 'n' && *(p-1) == ESC)) {
	    if(*p == 'n') p -= 2;
	    else --p;
    }
    p[1] = 0;
    *pCurChar = 0;
    yylval = save(yytext);
    return BODY;
}



/**
    regular code (not BODY mode)
   loop to eat up blanks and comments.  A comment starts with // and
   continues for the rest of the line.  If a single / is seen in the
   loop a '/' token is returned.
**/
int
yylexNormal(pCurChar)
    int *pCurChar;
{
    int		c = *pCurChar;
    char    	*p = yytext;
    int		key;

    while (1) {
	if (c != '/') {
	    break;
	} else {
		c = yyinput();
		if (c != '/') {
			*yytext = '/';
			yytext[1] = 0;
			*pCurChar = c;
			return '/';
		}
		/* comment -- eat rest of line */
		while ((c=yyinput()) != NEWLINE && c != EOF);
	}
	while (isspace(c)) { c = yyinput(); }
    }
    if (c == EOF) {
	*pCurChar = c;
	return 0;		
    }
    if (c == QUOTE) {
	/*
	 * STRING token includes surrounding quotes
	 * If the STRING includes a NEWLINE, a warning is issued.
	 */
	*p++ = c;
	while (1) {
		*p++ = c = yyinput();
		if (c == QUOTE) {
			*p = 0;
			break;
		}
		else if (c == ESC) {
			*p++ = c = yyinput();
		}
		else if (c == NEWLINE) {
			yywarn ("warning: multi-line string");
		}
		else if (c == EOF) {
			yyerror ("Unexpected EOF in string");
			exit (1);
		}
	}
	*pCurChar = 0;
	yylval = save(yytext);
	return STRING;
    } else if (c == '<') {
        /* Token like <stdio.h> */
	p = yytext;
	*p++ = c;
	while (1) {
	    *p++ = c = yyinput();
	    if (c == '>') {
		    *p = 0;
		    break;
	    } else if (c == EOF) {
		    yyerror ("Unexpected EOF in <> string");
		    exit (1);
	    }
	}
	*pCurChar = 0;
	yylval = save(yytext);
	return STRING;
    } else if (! IDENTCHAR(c) ) {
	    yytext[0] = c;
	    yytext[1] = 0;
	    *pCurChar = 0;
	    return yytext[0];
    } else {
        /* we also return numeric values as IDENTIFIER: 
	 * digits and '.' allowed
	 */
        do {
	    *p++ = c;
	    c = yyinput();
        } while ( IDENTCHAR(c) );
    }
    *p = 0;
    *pCurChar = c;
    yylval = save(yytext);
    if ((key = lookup (yytext)) != 0) {
	    return key;
    }
    return IDENTIFIER;
}

/* #define input() ((c = getc(yyin))==10?(yyline++,c):c) */

/* The lexical analyzer */
int yylex () {
    static int	c = 0;
    if (c == EOF) return 0;

    if (codeMode) {
	return yylexCode(&c);
    }
    while (c==0 || isspace(c)) {
	    c = yyinput();
    }
    if (bodyMode) {
	return yylexBody(&c);
    }

    if (descMode) {
	return yylexDesc(&c);
    }
    return yylexNormal(&c);
}

int lookup (text)
char* text;
{
	struct tentry *p = keyTable;
	while (p->key && strcmp (p->key, text) != 0) p++;
	return p->code;
}

/*
 * save token in dynamic memory
 * For the processing of codeblocks, its important that NULLs stay
 * NULL and that the empty string should remain an entry string.
 */
char* save(in)
char* in;
{
	char* out;
	if ( in == NULL )	return NULL;
	out = malloc((unsigned)strlen(in)+1);
	strcpy(out,in);
	return out;
}

char* savelineref()
{
    char buf[SMALLBUFSIZE];
    sprintf(buf, "# line %d \"%s\"", yyline, inputFile);
    return save(buf);
}

/**
    strip quotes, save token in dynamic memory
    A previous version of this used to special case the situation where
    the string was only two characters (presumbly just ``""'') and would
    return exactly that.  This breaks things, so now return an empty string
    (instead of ``""'') is returned -- kennard
**/
char* stripQuotes(in)
char* in;
{
	char* out;
	int l = strlen(in);
	if ( l<2 || in[0]!=QUOTE || in[l-1]!=QUOTE ) {
		yyerror("String without quotes in stripQuotes().");
		return save(in);
	}
	if ( l == 2 ) { return save(""); }
	out = malloc((unsigned)l-1);
	strncpy(out,in+1,l-2);
	/* strncpy does not necessarily null-terminate the string */
	out[l-2] = 0;
	return out;
}

/*
 * make sure a function is a valid arglist:
 * for now, must start with (, end with ), and have balanced parens.
 */
char* checkArgs(in)
char* in;
{
	char* ptr = in;
	int parenlevel = 0;

	if (*in != LPAR || in[strlen(in)-1] != RPAR)
		yyerror ("Invalid argument list");

	while (*ptr) {
		if (*ptr == LPAR)
			parenlevel++;
		else if (*ptr == RPAR && --parenlevel < 0)
			yyerror ("Mismatched parentheses in argument list");
		ptr++;
	}
	if (parenlevel != 0)
	  yyerror ("Mismatched parentheses in argument list");

	return in;
}

/*
 * copy arglist at *in to *out, deleting any default-argument specifications.
 * A default arg spec starts with '=' at paren level 1, and extends until a
 * ',' or ')' occuring at paren level 1.
 */
void stripDefaultArgs(out, in)
char* out;
char* in;
{
	int copying = 1;
	int parenlevel = 0;

	while (*in) {
	  switch (*in) {
	  case LPAR:
	    parenlevel++;
	    break;
	  case RPAR:
	    if (parenlevel == 1) copying = 1;
	    parenlevel--;
	    break;
	  case '=':
	    if (parenlevel == 1) copying = 0;
	    break;
	  case ',':
	    if (parenlevel == 1) copying = 1;
	    break;
	  }
	  if (copying) *out++ = *in;
	  in++;
	}
	*out = 0;
}

/*
 * copy one string into another, replacing the pattern "\n" with
 * NEWLINE, "\t" with tab, and "\x" with x for any other x.
 * The third argument is the size of the destination, which will not
 * be exceeded.
 */
int unescape(destination, source, dsize)
char* destination;
char* source;
int dsize;
{
	char* d = destination;
	char* s = source;
	int i = 1;
	while (*s != (char)NULL) {
	    if (*s == ESC) {
		switch (*(s+1)) {
		    case 'n':
			*d++ = '\n';
			break;
		    case 't':
			*d++ = '\t';
			break;
		    default:
			*d++ = *(s+1);
		}
		s += 2;
	    } else
		*d++ = *s++;
	    if(i++ >= dsize) {
		*d = (char)NULL; /* terminate the string */
		return(1);
	    }
	}
	*d = (char)NULL; /* terminate the string */
	return(0);
}

/* main program, just calls parser */
int main (argc, argv)
int argc;
char **argv;
{
	if (argc != 2) {
		fprintf (stderr, "Usage: %s file\n", *argv);
		exit (1);
	}
	inputFile = argv[1];
	if ((yyin = fopen (inputFile, "r")) == NULL) {
		perror (inputFile);
		exit (1);
	}
	yyparse ();
	return nerrs;
}

void yyerr2 (x, y)
char *x, *y;
{
	strcpy (str1, x);
	strcat (str1, y);
	yyerror (str1);
}

void yyerror(s)
char *s;
{
	/* ugly: figure out if yacc is reporting syntax error at EOF */
	if (strcmp(s, "syntax error") == 0 && yychar == 0)
		s = "Unexpected EOF (mismatched curly braces?)";
	fprintf (stderr, "\"%s\", line %d: %s\n", inputFile, yyline, s);
	nerrs++;
	return;
}

void yywarn(s)
char *s;
{
	fprintf (stderr, "\"%s\", line %d: %s\n", inputFile, yyline, s);
	return;
}

void mismatch(s)
char *s;
{
	yyerr2 ("Extra token appears after valid input: ", s);
	exit (1);
}

/* Check that we are not blowing the top off an array */
void checkIncludes(numIncludes)
int numIncludes;
{
	if (numIncludes > NINC) {
		fprintf (stderr, 
    "Too many include files(%d), recompile ptlang with NINC (%d) larger.\n",
		numIncludes, NINC);
		exit(1);
	}
}

/* Check that we are not blowing the top off an array */
void checkSeeAlsos(numSeeAlsos)
int numSeeAlsos;
{
	if (numSeeAlsos > NSEE) {
		fprintf (stderr, 
	 "Too many see alsos (%d), recompile ptlang with NSEE (%d) larger.\n",
		numSeeAlsos, NSEE);
		exit(1);
	}
}
