/*
Copyright (c) 1990-1995 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2
						COPYRIGHTENDKEY
*/
/*
 * Gabriel slider package.
 *
 * @(#)gslider.h	1.5	3/2/95
 */

/* libgslider is used to make a non-qdm version of a slider for the
 * s56 dsp card.  The star that uses this is CG56HostSliderGX.pl
 */

/*
 * gsl_read makes a linked list of the following structure, one
 * entry per line of the "0code.sld" file generated by Gabriel.
 * The "user" field is initially NULL, and can be set to point
 * to whatever data the user wants (e.g., X widgets).
 */
struct gslider {
	char	*dsplabel;	/* DSP memory location label */
	char	*name;		/* name (typically "") */
	char	*descr;		/* description */
	double	hostmin;	/* host minimum value */
	double	hostmax;	/* host maximum value */
	double	hostinit;	/* host initial value */
	double	dspmin;		/* dsp minimum value */
	double	dspmax;		/* dsp maximum value */
	int	rep;		/* representation (db or linear) */
	char	*user;		/* user data */
	struct gslider *next;
};

#define	GSL_REP_LINEAR	0
#define	GSL_REP_DB	1

typedef struct gslider	Gslider;

extern	Gslider	*gsl_read();
