static const char file_id[] = "MatlabIfcFuns.cc";

/**************************************************************************
Version identification:
@(#)MatlabIfcFuns.cc	1.1	11/6/95

Copyright (c) 1990-1996 The Regents of the University of California.
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

						PT_COPYRIGHT_VERSION_2

 Programmer:  Brian L. Evans
 Date of creation: 11/6/95
 Revisions:

 Default functions for the Ptolemy interface to Matlab.

**************************************************************************/

// Ptolemy Error class
#include "Error.h"
#include "MatlabIfcFuns.h"

//
// MATLAB Engine Routines
//

inline void engPtError() {
	Error::abortRun( "The external interface to Matlab has not been ",
			 "compiled into Ptolemy." );
}

// send a command to the Matlab Engine for evaluation
extern "C" int engEvalString(Engine* /*enginePtr*/, char* /*command*/) {
	engPtError();
	return 0;
}

// start a Matlab process
extern "C" Engine* engOpen(char* /*unixCommand*/) {
	engPtError();
	return 0;
}
    
// close the Matlab connection
extern "C" int engClose(Engine* /*enginePtr*/) {
	engPtError();
	return 0;
}

// get pointer to a copy of a Matlab matrix
extern "C" Matrix* engGetMatrix(Engine* /*enginePtr*/, char* /*name*/) {
	engPtError();
	return 0;
}

// put a matrix in the Matlab environment (Matlab will copy the matrix)
extern "C" int engPutMatrix(Engine* /*enginePtr*/, Matrix* /*matrixPtr*/) {
	engPtError();
	return 0;
}

extern "C" int engGetFull(Engine* /*enginePtr*/, char* /*name*/,
			  int* /*numrows*/, int* /*numcols*/,
			  Real** /*realPartPtr*/, Real** /*imagePartPtr*/) {
	engPtError();
	return 0;
}

extern "C" int engPutFull(Engine* /*enginePtr*/, char* /*name*/,
			  int /*numrows*/, int /*numcols*/,
			  Real* /*realPartPtr*/, Real* /*imagePartPtr*/ ) {
	engPtError();
	return 0;
}

// tell Matlab where to put the output of computations
extern "C" int engOutputBuffer(Engine* /*enginePtr*/,
			       char* /*buffer*/,
			       int /*buferLength*/) {
	engPtError();
	return 0;
}

//
// MATLAB Matrix Routines
//

inline void mxPtError() {
	Error::abortRun( "The Matlab matrix manipulation routines have ",
			 "not been compiled into Ptolemy." );
}

extern "C" Matrix* mxCreateFull(int /*numrows*/,
				int /*numcols*/,
				int /*complexFlag*/) {
	mxPtError();
	return 0;
}

extern "C" void mxFreeMatrix(Matrix* /*matrixPtr*/) {
        mxPtError();
}

extern "C" void* mxCalloc(unsigned int /*numelements*/,
			 unsigned int /*size*/) {
	mxPtError();
	return 0;
}

extern "C" void mxFree(void* /*memoryPtr*/) {
	mxPtError();
}

extern "C" const char* mxGetName(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetName(Matrix* /*matrixPtr*/, const char* /*name*/) {
	mxPtError();
}

extern "C" int mxGetM(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetM(Matrix* /*matrixPtr*/, int /*numrows*/) {
	mxPtError();
}

extern "C" int mxGetN(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetN(Matrix* /*matrixPtr*/, int /*numcols*/) {
	mxPtError();
}

extern "C" Real* mxGetPr(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetPr(Matrix* /*matrixPtr*/, Real* /*realMatrixPtr*/) {
	mxPtError();
}

extern "C" Real* mxGetPi(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetPi(Matrix* /*matrixPtr*/, Real* /*imagMatrixPtr*/) {
	mxPtError();
}

extern "C" int mxGetNzmax(const Matrix* /*matrixPtr*/) {;
	mxPtError();
	return 0;
}

extern "C" void mxSetNzmax(Matrix* /*matrixPtr*/, int /*numNonZeroElements*/) {
	mxPtError();
}

extern "C" int* mxGetIr(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetIr(Matrix* /*matrixPtr*/, int* /*sparseIndexArray*/) {
	mxPtError();
}

extern "C" int* mxGetJc(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetJc(Matrix* /*matrixPtr*/, int* /*sparseIndexArray*/) {
	mxPtError();
}

extern "C" int mxGetString(const Matrix* /*matrixPtr*/, char* /*buffer*/,
			   int /*bufferLength*/) {
	mxPtError();
	return 0;
}

extern "C" Matrix* mxCreateString(const char* /*string*/) {
	mxPtError();
	return 0;
}

extern "C" double mxGetScalar(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" int mxIsFull(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" int mxIsSparse(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" int mxIsDouble(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" void mxSetString(Matrix* /*matrixPtr*/) {
	mxPtError();
}

extern "C" int mxIsString(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" int mxIsNumeric(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" int mxIsComplex(const Matrix* /*matrixPtr*/) {
	mxPtError();
	return 0;
}

extern "C" Matrix* mxCreateSparse(int /*numrows*/,
				  int /*numcols*/,
				  int /*numNonZeroElements*/,
				  int /*complexFlag*/) {
	mxPtError();
	return 0;
}
